searchNodes=[{"doc":"Prints Nebulex tasks and their information. mix nbx","ref":"Mix.Tasks.Nbx.html","title":"Mix.Tasks.Nbx","type":"task"},{"doc":"Generates a new cache. The cache will be placed in the lib directory. For generating a cache with the config, you can run: mix nbx . gen . cache - c MyApp.Cache Besides, you can also specify the adapter you want to use, like so: mix nbx . gen . cache - c MyApp.PartitionedCache - a Nebulex.Adapters.Local mix nbx . gen . cache - c MyApp.PartitionedCache - a Nebulex.Adapters.Partitioned mix nbx . gen . cache - c MyApp.ReplicatedCache - a Nebulex.Adapters.Replicated mix nbx . gen . cache - c MyApp.MultilevelCache - a Nebulex.Adapters.Multilevel Command line options -c , --cache - The cache to generate. -a , --adapter - The cache adapter to use (optional). Defaults to Nebulex.Adapters.Local .","ref":"Mix.Tasks.Nbx.Gen.Cache.html","title":"Mix.Tasks.Nbx.Gen.Cache","type":"task"},{"doc":"Nebulex is split into 2 main components: Nebulex.Cache - caches are wrappers around the in-memory data store. Via the cache, we can put, get, update, delete and query existing entries. A cache needs an adapter to communicate to the in-memory data store. Nebulex.Caching - decorators provide an elegant way of annotating functions to be cached or evicted. By means of these decorators, it is possible the implementation of cache usage patterns like Read-through , Write-through , Cache-as-SoR , etc. In the following sections, we will provide an overview of those components and how they interact with each other. Feel free to access their respective module documentation for more specific examples, options and configuration. If you want to quickly check a sample application using Nebulex, please check the getting started guide . Caches Nebulex.Cache is the wrapper around the Cache. We can define a cache as follows: defmodule MyApp.MyCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end Where the configuration for the Cache must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.MyCache , gc_interval : 3_600_000 , #=&gt; 1 hr backend : :shards , partitions : 2 Each cache in Nebulex defines a start_link/1 function that needs to be invoked before using the cache. In general, this function is not called directly, but used as part of your application supervision tree. If your application was generated with a supervisor (by passing --sup to mix new ) you will have a lib/my_app/application.ex file containing the application start callback that defines and starts your supervisor. You just need to edit the start/2 function to start the cache as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { MyApp.Cache , [ ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Otherwise, you can start and stop the cache directly at any time by calling MyApp.Cache.start_link/1 and MyApp.Cache.stop/1 . Declarative annotation-based caching See Nebulex.Caching .","ref":"Nebulex.html","title":"Nebulex","type":"module"},{"doc":"Specifies the minimal API required from adapters.","ref":"Nebulex.Adapter.html","title":"Nebulex.Adapter","type":"behaviour"},{"doc":"The callback invoked in case the adapter needs to inject code.","ref":"Nebulex.Adapter.html#c:__before_compile__/1","title":"Nebulex.Adapter.__before_compile__/1","type":"macrocallback"},{"doc":"Helper macro for the adapters so they can add the logic for emitting the recommended Telemetry events. See the built-in adapters for more information on how to use this macro.","ref":"Nebulex.Adapter.html#defspan/3","title":"Nebulex.Adapter.defspan/3","type":"macro"},{"doc":"Initializes the adapter supervision tree by returning the children.","ref":"Nebulex.Adapter.html#c:init/1","title":"Nebulex.Adapter.init/1","type":"callback"},{"doc":"Executes the function fun passing as parameters the adapter and metadata (from the init/1 callback) associated with the given cache name_or_pid . It expects a name or a PID representing the cache.","ref":"Nebulex.Adapter.html#with_meta/2","title":"Nebulex.Adapter.with_meta/2","type":"function"},{"doc":"The metadata returned by the adapter init/1 . It must be a map and Nebulex itself will always inject two keys into the meta: :cache - The cache module. :pid - The PID returned by the child spec returned in init/1","ref":"Nebulex.Adapter.html#t:adapter_meta/0","title":"Nebulex.Adapter.adapter_meta/0","type":"type"},{"doc":"Metadata type","ref":"Nebulex.Adapter.html#t:metadata/0","title":"Nebulex.Adapter.metadata/0","type":"type"},{"doc":"Adapter","ref":"Nebulex.Adapter.html#t:t/0","title":"Nebulex.Adapter.t/0","type":"type"},{"doc":"Specifies the entry API required from adapters. This behaviour specifies all read/write key-based functions, the ones applied to a specific cache entry.","ref":"Nebulex.Adapter.Entry.html","title":"Nebulex.Adapter.Entry","type":"behaviour"},{"doc":"Deletes a single entry from cache. See Nebulex.Cache.delete/2 .","ref":"Nebulex.Adapter.Entry.html#c:delete/3","title":"Nebulex.Adapter.Entry.delete/3","type":"callback"},{"doc":"Returns true if the given key exists and the new ttl was successfully updated, otherwise, false is returned. See Nebulex.Cache.expire/2 .","ref":"Nebulex.Adapter.Entry.html#c:expire/3","title":"Nebulex.Adapter.Entry.expire/3","type":"callback"},{"doc":"Gets the value for a specific key in cache . See Nebulex.Cache.get/2 .","ref":"Nebulex.Adapter.Entry.html#c:get/3","title":"Nebulex.Adapter.Entry.get/3","type":"callback"},{"doc":"Gets a collection of entries from the Cache, returning them as Map.t() of the values associated with the set of keys requested. For every key that does not hold a value or does not exist, that key is simply ignored. Because of this, the operation never fails. See Nebulex.Cache.get_all/2 .","ref":"Nebulex.Adapter.Entry.html#c:get_all/3","title":"Nebulex.Adapter.Entry.get_all/3","type":"callback"},{"doc":"Returns whether the given key exists in cache. See Nebulex.Cache.has_key?/1 .","ref":"Nebulex.Adapter.Entry.html#c:has_key?/2","title":"Nebulex.Adapter.Entry.has_key?/2","type":"callback"},{"doc":"Puts the given value under key into the cache . Returns true if the value with key key is successfully inserted; otherwise false is returned. The ttl argument sets the time-to-live for the stored entry. If it is not set, it means the entry hasn't a time-to-live, then it shouldn't expire. OnWrite The on_write argument supports the following values: :put - If the key already exists, it is overwritten. Any previous time-to-live associated with the key is discarded on successful write operation. :put_new - It only stores the entry if the key does not already exist, otherwise, false is returned. :replace - Alters the value stored under the given key , but only if the key already exists into the cache, otherwise, false is returned. See Nebulex.Cache.put/3 , Nebulex.Cache.put_new/3 , Nebulex.Cache.replace/3 .","ref":"Nebulex.Adapter.Entry.html#c:put/6","title":"Nebulex.Adapter.Entry.put/6","type":"callback"},{"doc":"Puts the given entries (key/value pairs) into the cache . Returns true if all the keys were inserted. If no key was inserted (at least one key already existed), false is returned. The ttl argument sets the time-to-live for the stored entry. If it is not set, it means the entry hasn't a time-to-live, then it shouldn't expire. The given ttl is applied to all keys. OnWrite The on_write argument supports the following values: :put - If the key already exists, it is overwritten. Any previous time-to-live associated with the key is discarded on successful write operation. :put_new - It only stores the entry if the key does not already exist, otherwise, false is returned. Ideally, this operation should be atomic, so all given keys are set at once. But it depends purely on the adapter's implementation and the backend used internally by the adapter. Hence, it is recommended to checkout the adapter's documentation. See Nebulex.Cache.put_all/2 .","ref":"Nebulex.Adapter.Entry.html#c:put_all/5","title":"Nebulex.Adapter.Entry.put_all/5","type":"callback"},{"doc":"Returns and removes the entry with key key in the cache. See Nebulex.Cache.take/2 .","ref":"Nebulex.Adapter.Entry.html#c:take/3","title":"Nebulex.Adapter.Entry.take/3","type":"callback"},{"doc":"Returns true if the given key exists and the last access time was successfully updated, otherwise, false is returned. See Nebulex.Cache.touch/1 .","ref":"Nebulex.Adapter.Entry.html#c:touch/2","title":"Nebulex.Adapter.Entry.touch/2","type":"callback"},{"doc":"Returns the TTL (time-to-live) for the given key . If the key does not exist, then nil is returned. See Nebulex.Cache.ttl/1 .","ref":"Nebulex.Adapter.Entry.html#c:ttl/2","title":"Nebulex.Adapter.Entry.ttl/2","type":"callback"},{"doc":"Updates the counter mapped to the given key . If amount &gt; 0, the counter is incremented by the given amount . If amount &lt; 0, the counter is decremented by the given amount . If amount == 0, the counter is not updated. See Nebulex.Cache.incr/3 . See Nebulex.Cache.decr/3 .","ref":"Nebulex.Adapter.Entry.html#c:update_counter/6","title":"Nebulex.Adapter.Entry.update_counter/6","type":"callback"},{"doc":"Proxy type to the adapter meta","ref":"Nebulex.Adapter.Entry.html#t:adapter_meta/0","title":"Nebulex.Adapter.Entry.adapter_meta/0","type":"type"},{"doc":"Proxy type to the cache entries","ref":"Nebulex.Adapter.Entry.html#t:entries/0","title":"Nebulex.Adapter.Entry.entries/0","type":"type"},{"doc":"Proxy type to the cache key","ref":"Nebulex.Adapter.Entry.html#t:key/0","title":"Nebulex.Adapter.Entry.key/0","type":"type"},{"doc":"Write command","ref":"Nebulex.Adapter.Entry.html#t:on_write/0","title":"Nebulex.Adapter.Entry.on_write/0","type":"type"},{"doc":"Proxy type to the cache options","ref":"Nebulex.Adapter.Entry.html#t:opts/0","title":"Nebulex.Adapter.Entry.opts/0","type":"type"},{"doc":"TTL for a cache entry","ref":"Nebulex.Adapter.Entry.html#t:ttl/0","title":"Nebulex.Adapter.Entry.ttl/0","type":"type"},{"doc":"Proxy type to the cache value","ref":"Nebulex.Adapter.Entry.html#t:value/0","title":"Nebulex.Adapter.Entry.value/0","type":"type"},{"doc":"This behaviour provides a callback to compute the hash slot for a specific key based on the number of slots (partitions, nodes, ...). The purpose of this module is to allow users to implement a custom hash-slot function to distribute the keys. It can be used to select the node/slot where a specific key is supposed to be. It is highly recommended to use a Consistent Hashing algorithm. Example defmodule MyApp.Keyslot do use Nebulex.Adapter.Keyslot @impl true def hash_slot ( key , range ) do key |&gt; :erlang . phash2 ( ) |&gt; :jchash . compute ( range ) end end This example uses Jumping Consistent Hash .","ref":"Nebulex.Adapter.Keyslot.html","title":"Nebulex.Adapter.Keyslot","type":"behaviour"},{"doc":"Returns an integer within the range 0..range-1 identifying the hash slot the specified key hashes to. Example iex&gt; MyKeyslot . hash_slot ( &quot;mykey&quot; , 10 ) 2","ref":"Nebulex.Adapter.Keyslot.html#c:hash_slot/2","title":"Nebulex.Adapter.Keyslot.hash_slot/2","type":"callback"},{"doc":"Specifies the adapter persistence API. Default implementation This module provides a default implementation that uses File and Stream under-the-hood. For dumping a cache to a file, the entries are streamed from the cache and written in chunks (one chunk per line), and each chunk contains N number of entries. For loading the entries from a file, the file is read and streamed line-by-line, so that the entries collected on each line are inserted in streaming fashion as well. The default implementation accepts the following options only for dump operation (there are not options for load ): entries_per_line - The number of entries to be written per line in the file. Defaults to 10 . compression - The compression level. The values are the same as :erlang.term_to_binary /2 . Defaults to 6 . See Nebulex.Cache.dump/2 and Nebulex.Cache.load/2 for more information.","ref":"Nebulex.Adapter.Persistence.html","title":"Nebulex.Adapter.Persistence","type":"behaviour"},{"doc":"Dumps a cache to the given file path . Returns :ok if successful, or {:error, reason} if an error occurs. See Nebulex.Cache.dump/2 .","ref":"Nebulex.Adapter.Persistence.html#c:dump/3","title":"Nebulex.Adapter.Persistence.dump/3","type":"callback"},{"doc":"Loads a dumped cache from the given path . Returns :ok if successful, or {:error, reason} if an error occurs. See Nebulex.Cache.load/2 .","ref":"Nebulex.Adapter.Persistence.html#c:load/3","title":"Nebulex.Adapter.Persistence.load/3","type":"callback"},{"doc":"Specifies the query API required from adapters. Query values There are two types of query values. The ones shared and implemented by all adapters and the ones that are adapter specific. Common queries The following query values are shared and/or supported for all adapters: nil - Matches all cached entries. Adapter-specific queries The query value depends entirely on the adapter implementation; it could any term. Therefore, it is highly recommended to see adapters' documentation for more information about building queries. For example, the built-in Nebulex.Adapters.Local adapter uses :ets.match_spec() for queries, as well as other pre-defined ones like :unexpired and :expired .","ref":"Nebulex.Adapter.Queryable.html","title":"Nebulex.Adapter.Queryable","type":"behaviour"},{"doc":"Executes the query according to the given operation . Raises Nebulex.QueryError if query is invalid. In the the adapter does not support the given operation , an ArgumentError exception should be raised. Operations :all - Returns a list with all entries from cache matching the given query . :count_all - Returns the number of matched entries with the given query . :delete_all - Deletes all entries matching the given query . It returns the number of deleted entries. It is used on Nebulex.Cache.all/2 , Nebulex.Cache.count_all/2 , and Nebulex.Cache.delete_all/2 .","ref":"Nebulex.Adapter.Queryable.html#c:execute/4","title":"Nebulex.Adapter.Queryable.execute/4","type":"callback"},{"doc":"Streams the given query . Raises Nebulex.QueryError if query is invalid. See Nebulex.Cache.stream/2 .","ref":"Nebulex.Adapter.Queryable.html#c:stream/3","title":"Nebulex.Adapter.Queryable.stream/3","type":"callback"},{"doc":"Proxy type to the adapter meta","ref":"Nebulex.Adapter.Queryable.html#t:adapter_meta/0","title":"Nebulex.Adapter.Queryable.adapter_meta/0","type":"type"},{"doc":"Proxy type to the cache options","ref":"Nebulex.Adapter.Queryable.html#t:opts/0","title":"Nebulex.Adapter.Queryable.opts/0","type":"type"},{"doc":"Specifies the stats API required from adapters. Each adapter is responsible for providing support for stats by implementing this behaviour. However, this module brings with a default implementation using [Erlang counters][ https://erlang.org/doc/man/counters.html] , with all callbacks overridable, which is supported by the built-in adapters. See Nebulex.Adapters.Local for more information about how this can be used from the adapter, and also Nebulex Telemetry Guide to learn how to use the Cache with Telemetry.","ref":"Nebulex.Adapter.Stats.html","title":"Nebulex.Adapter.Stats","type":"behaviour"},{"doc":"Increments the counter 's stat_name by the given incr value. Examples Nebulex.Adapter.Stats . incr ( stats_counter , :hits ) Nebulex.Adapter.Stats . incr ( stats_counter , :writes , 10 ) NOTE: This function is usually called by the adapter in case it uses the default implementation; the adapter should feed Nebulex.Stats.t() counters. See adapters documentation for more information about stats implementation.","ref":"Nebulex.Adapter.Stats.html#incr/3","title":"Nebulex.Adapter.Stats.incr/3","type":"function"},{"doc":"Initializes the Erlang's counter to be used by the adapter. See the module documentation for more information about the stats default implementation. Returns nil is the option :stats is set to false or it is not set at all; the stats will be skipped. Example Nebulex.Adapter.Stats . init ( opts ) NOTE: This function is usually called by the adapter in case it uses the default implementation; the adapter should feed Nebulex.Stats.t() counters. See adapters documentation for more information about stats implementation.","ref":"Nebulex.Adapter.Stats.html#init/1","title":"Nebulex.Adapter.Stats.init/1","type":"function"},{"doc":"Returns Nebulex.Stats.t() with the current stats values. If the stats are disabled for the cache, then nil is returned. The adapter may also include additional custom measurements, as well as metadata. See Nebulex.Cache.stats/0 .","ref":"Nebulex.Adapter.Stats.html#c:stats/1","title":"Nebulex.Adapter.Stats.stats/1","type":"callback"},{"doc":"Specifies the adapter transactions API. Default implementation This module also provides a default implementation which uses the Erlang library :global . This implementation accepts the following options: :keys - The list of the keys that will be locked. Since the lock id is generated based on the key, if this option is not set, a fixed/constant lock id is used to perform the transaction, then all further transactions (without this option set) are serialized and the performance is affected significantly. For that reason it is recommended to pass the list of keys involved in the transaction. :nodes - The list of the nodes where the lock will be set, or on all nodes if none are specified. :retries - If the key has been locked by other process already, and :retries is not equal to 0, the process sleeps for a while and tries to execute the action later. When :retries attempts have been made, an exception is raised. If :retries is :infinity (the default), the function will eventually be executed (unless the lock is never released). Let's see an example: MyCache . transaction fn -&gt; counter = MyCache . get ( :counter ) MyCache . set ( :counter , counter + 1 ) end Locking only the involved key (recommended): MyCache . transaction [ keys : [ :counter ] ] , fn -&gt; counter = MyCache . get ( :counter ) MyCache . set ( :counter , counter + 1 ) end MyCache . transaction [ keys : [ :alice , :bob ] ] , fn -&gt; alice = MyCache . get ( :alice ) bob = MyCache . get ( :bob ) MyCache . set ( :alice , %{ alice | balance : alice . balance + 100 } ) MyCache . set ( :bob , %{ bob | balance : bob . balance + 100 } ) end","ref":"Nebulex.Adapter.Transaction.html","title":"Nebulex.Adapter.Transaction","type":"behaviour"},{"doc":"Returns true if the given process is inside a transaction. See Nebulex.Cache.in_transaction?/0 .","ref":"Nebulex.Adapter.Transaction.html#c:in_transaction?/1","title":"Nebulex.Adapter.Transaction.in_transaction?/1","type":"callback"},{"doc":"Runs the given function inside a transaction. A successful transaction returns the value returned by the function. See Nebulex.Cache.transaction/2 .","ref":"Nebulex.Adapter.Transaction.html#c:transaction/3","title":"Nebulex.Adapter.Transaction.transaction/3","type":"callback"},{"doc":"Adapter module for Local Generational Cache; inspired by epocxy . Generational caching using an ets table (or multiple ones when used with :shards ) for each generation of cached data. Accesses hit the newer generation first, and migrate from the older generation to the newer generation when retrieved from the stale table. When a new generation is started, the oldest one is deleted. This is a form of mass garbage collection which avoids using timers and expiration of individual cached elements. This implementation of generation cache uses only two generations (which is more than enough) also referred like the newer and the older . Overall features Configurable backend ( ets or :shards ). Expiration – A status based on TTL (Time To Live) option. To maintain cache performance, expired entries may not be immediately removed or evicted, they are expired or evicted on-demand, when the key is read. Eviction – Generational Garbage Collection . Sharding – For intensive workloads, the Cache may also be partitioned (by using :shards backend and specifying the :partitions option). Support for transactions via Erlang global name registration facility. Support for stats. Options This adapter supports the following options and all of them can be given via the cache configuration: :backend - Defines the backend or storage to be used for the adapter. Supported backends are: :ets and :shards . Defaults to :ets . :read_concurrency - (boolean) Since this adapter uses ETS tables internally, this option is used when a new table is created; see :ets.new/2 . Defaults to true . :write_concurrency - (boolean) Since this adapter uses ETS tables internally, this option is used when a new table is created; see :ets.new/2 . Defaults to true . :compressed - (boolean) This option is used when a new ETS table is created and it defines whether or not it includes X as an option; see :ets.new/2 . Defaults to false . :backend_type - This option defines the type of ETS to be used (Defaults to :set ). However, it is highly recommended to keep the default value, since there are commands not supported (unexpected exception may be raised) for types like :bag or : duplicate_bag . Please see the ETS docs for more information. :partitions - If it is set, an integer &gt; 0 is expected, otherwise, it defaults to System.schedulers_online() . This option is only available for :shards backend. :gc_interval - If it is set, an integer &gt; 0 is expected defining the interval time in milliseconds to garbage collection to run, delete the oldest generation and create a new one. If this option is not set, garbage collection is never executed, so new generations must be created explicitly, e.g.: MyCache.new_generation(opts) . :max_size - If it is set, an integer &gt; 0 is expected defining the max number of cached entries (cache limit). If it is not set ( nil ), the check to release memory is not performed (the default). :allocated_memory - If it is set, an integer &gt; 0 is expected defining the max size in bytes allocated for a cache generation. When this option is set and the configured value is reached, a new cache generation is created so the oldest is deleted and force releasing memory space. If it is not set ( nil ), the cleanup check to release memory is not performed (the default). :gc_cleanup_min_timeout - An integer &gt; 0 defining the min timeout in milliseconds for triggering the next cleanup and memory check. This will be the timeout to use when either the max size or max allocated memory is reached. Defaults to 10_000 (10 seconds). :gc_cleanup_max_timeout - An integer &gt; 0 defining the max timeout in milliseconds for triggering the next cleanup and memory check. This is the timeout used when the cache starts and there are few entries or the consumed memory is near to 0 . Defaults to 600_000 (10 minutes). Usage Nebulex.Cache is the wrapper around the cache. We can define a local cache as follows: defmodule MyApp.LocalCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end Where the configuration for the cache must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.LocalCache , gc_interval : :timer . hours ( 12 ) , max_size : 1_000_000 , allocated_memory : 2_000_000_000 , gc_cleanup_min_timeout : :timer . seconds ( 10 ) , gc_cleanup_max_timeout : :timer . minutes ( 10 ) For intensive workloads, the Cache may also be partitioned using :shards as cache backend ( backend: :shards ) and configuring the desired number of partitions via the :partitions option. Defaults to System.schedulers_online() . config :my_app , MyApp.LocalCache , gc_interval : :timer . hours ( 12 ) , max_size : 1_000_000 , allocated_memory : 2_000_000_000 , gc_cleanup_min_timeout : :timer . seconds ( 10 ) , gc_cleanup_max_timeout : :timer . minutes ( 10 ) , backend : :shards , partitions : System . schedulers_online ( ) * 2 If your application was generated with a supervisor (by passing --sup to mix new ) you will have a lib/my_app/application.ex file containing the application start callback that defines and starts your supervisor. You just need to edit the start/2 function to start the cache as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { MyApp.LocalCache , [ ] } , ... ] See Nebulex.Cache for more information. Eviction configuration This section is to understand a bit better how the different configuration options work and have an idea what values to set; especially if it is the first time using Nebulex. :ttl option The :ttl option that is used to set the expiration time for a key, it doesn't work as eviction mechanism, since the local adapter implements a generational cache, the options that control the eviction process are: :gc_interval , :gc_cleanup_min_timeout , :gc_cleanup_max_timeout , :max_size and :allocated_memory . The :ttl is evaluated on-demand when a key is retrieved, and at that moment if it s expired, then remove it from the cache, hence, it can not be used as eviction method, it is more for keep the integrity and consistency in the cache. For this reason, it is highly recommended to configure always the eviction options mentioned before. Caveats when using :ttl option: When using the :ttl option, ensure it is less than :gc_interval , otherwise, there may be a situation where the key is evicted and the :ttl hasn't happened yet (maybe because the garbage collector ran before the key had been fetched). Assuming you have :gc_interval set to 2 hrs, then you put a new key with :ttl set to 1 hr, and 1 minute later the GC runs, that key will be moved to the older generation so it can be yet retrieved. On the other hand, if the key is never fetched till the next GC cycle (causing moving it to the newer generation), since the key is already in the oldest generation it will be evicted from the cache so it won't be retrievable anymore. Garbage collection or eviction options This adapter implements a generational cache, which means its main eviction mechanism is pushing a new cache generation and remove the oldest one. In this way, we ensure only the most frequently used keys are always available in the newer generation and the the least frequently used are evicted when the garbage collector runs, and the garbage collector is triggered uppon these conditions: When the time interval defined by :gc_interval is completed. This makes the garbage-collector process to run creating a new generation and forcing to delete the oldest one. When the &quot;cleanup&quot; timeout expires, and then the limits :max_size and :allocated_memory are checked, if one of those is reached, then the garbage collector runs (a new generation is created and the oldest one is deleted). The cleanup timeout is controlled by :gc_cleanup_min_timeout and :gc_cleanup_max_timeout , it works with an inverse linear backoff, which means the timeout is inverse proportional to the memory growth; the bigger the cache size is, the shorter the cleanup timeout will be. First-time configuration For configuring the cache with accurate and/or good values it is important to know several things in advance, like for example the size of an entry in average so we can calculate a good value for max size and/or allocated memory, how intensive will be the load in terms of reads and writes, etc. The problem is most of these aspects are unknown when it is a new app or we are using the cache for the first time. Therefore, the following recommendations will help you to configure the cache for the first time: When configuring the :gc_interval , think about how that often the least frequently used entries should be evicted, or what is the desired retention period for the cached entries. For example, if :gc_interval is set to 1 hr, it means you will keep in cache only those entries that are retrieved periodically within a 2 hr period; gc_interval * 2 , being 2 the number of generations. Longer than that, the GC will ensure is always evicted (the oldest generation is always deleted). If it is the first time using Nebulex, perhaps you can start with gc_interval: :timer.hours(12) (12 hrs), so the max retention period for the keys will be 1 day; but ensure you also set either the :max_size or :allocated_memory . It is highly recommended to set either :max_size or :allocated_memory to ensure the oldest generation is deleted (least frequently used keys are evicted) when one of these limits is reached and also to avoid running out of memory. For example, for the :allocated_memory we can set 25% of the total memory, and for the :max_size something between 100_000 and 1_000_000 . For :gc_cleanup_min_timeout we can set 10_000 , which means when the cache is reaching the size or memory limit, the polling period for the cleanup process will be 10 seconds. And for :gc_cleanup_max_timeout we can set 600_000 , which means when the cache is almost empty the polling period will be close to 10 minutes. Stats This adapter does support stats by using the default implementation provided by Nebulex.Adapter.Stats . The adapter also uses the Nebulex.Telemetry.StatsHandler to aggregate the stats and keep them updated. Therefore, it requires the Telemetry events are emitted by the adapter (the :telemetry option should not be set to false so the Telemetry events can be dispatched), otherwise, stats won't work properly. Queryable API The adapter supports as query parameter the following values: query - nil | :unexpired | :expired | :ets.match_spec() Internally, an entry is represented by the tuple {key, val, vsn, exp} , which means the match pattern within the :ets.match_spec() must be something like {:&quot;$1&quot;, :&quot;$2&quot;, :&quot;$3&quot;, :&quot;$4&quot;} . In order to make query building easier, you can use Ex2ms library. Examples # built-in queries MyCache . all ( ) MyCache . all ( :unexpired ) MyCache . all ( :expired ) # using a custom match spec (all values &gt; 10) spec = [ { { :_ , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 10 } ] , [ { { :&quot;$1&quot; , :&quot;$2&quot; } } ] } ] MyCache . all ( spec ) # using Ex2ms import Ex2ms spec = fun do { _ , key , value , _ , _ } when value &gt; 10 -&gt; { key , value } end MyCache . all ( spec ) The :return option applies only for built-in queries, such as: nil | :unexpired | :expired , if you are using a custom :ets.match_spec() , the return value depends on it. The same applies to the stream function. Extended API (convenience functions) This adapter provides some additional convenience functions to the Nebulex.Cache API. Creating new generations: MyCache . new_generation ( ) MyCache . new_generation ( reset_timer : false ) Retrieving the current generations: MyCache . generations ( ) Retrieving the newer generation: MyCache . newer_generation ( )","ref":"Nebulex.Adapters.Local.html","title":"Nebulex.Adapters.Local","type":"module"},{"doc":"","ref":"Nebulex.Adapters.Local.html#entry/1","title":"Nebulex.Adapters.Local.entry/1","type":"macro"},{"doc":"","ref":"Nebulex.Adapters.Local.html#entry/2","title":"Nebulex.Adapters.Local.entry/2","type":"macro"},{"doc":"","ref":"Nebulex.Adapters.Local.html#get_/2","title":"Nebulex.Adapters.Local.get_/2","type":"function"},{"doc":"","ref":"Nebulex.Adapters.Local.html#take_/2","title":"Nebulex.Adapters.Local.take_/2","type":"function"},{"doc":"Generational garbage collection process. The generational garbage collector manage the heap as several sub-heaps, known as generations, based on age of the objects. An object is allocated in the youngest generation, sometimes called the nursery, and is promoted to an older generation if its lifetime exceeds the threshold of its current generation (defined by option :gc_interval ). Everytime the GC runs (triggered by :gc_interval timeout), a new cache generation is created and the oldest one is deleted. The only way to create new generations is through this module (this server is the metadata owner) calling new/2 function. When a Cache is created, a generational garbage collector is attached to it automatically, therefore, this server MUST NOT be started directly. Options These options are configured through the Nebulex.Adapters.Local adapter: :gc_interval - If it is set, an integer &gt; 0 is expected defining the interval time in milliseconds to garbage collection to run, delete the oldest generation and create a new one. If this option is not set, garbage collection is never executed, so new generations must be created explicitly, e.g.: MyCache.new_generation(opts) . :max_size - If it is set, an integer &gt; 0 is expected defining the max number of cached entries (cache limit). If it is not set ( nil ), the check to release memory is not performed (the default). :allocated_memory - If it is set, an integer &gt; 0 is expected defining the max size in bytes allocated for a cache generation. When this option is set and the configured value is reached, a new cache generation is created so the oldest is deleted and force releasing memory space. If it is not set ( nil ), the cleanup check to release memory is not performed (the default). :gc_cleanup_min_timeout - An integer &gt; 0 defining the min timeout in milliseconds for triggering the next cleanup and memory check. This will be the timeout to use when either the max size or max allocated memory is reached. Defaults to 10_000 (10 seconds). :gc_cleanup_max_timeout - An integer &gt; 0 defining the max timeout in milliseconds for triggering the next cleanup and memory check. This is the timeout used when the cache starts and there are few entries or the consumed memory is near to 0 . Defaults to 600_000 (10 minutes).","ref":"Nebulex.Adapters.Local.Generation.html","title":"Nebulex.Adapters.Local.Generation","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nebulex.Adapters.Local.Generation.html#child_spec/1","title":"Nebulex.Adapters.Local.Generation.child_spec/1","type":"function"},{"doc":"Removes or flushes all entries from the cache (including all its generations). Example Nebulex.Adapters.Local.Generation . delete_all ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#delete_all/1","title":"Nebulex.Adapters.Local.Generation.delete_all/1","type":"function"},{"doc":"A convenience function for retrieving the state.","ref":"Nebulex.Adapters.Local.Generation.html#get_state/1","title":"Nebulex.Adapters.Local.Generation.get_state/1","type":"function"},{"doc":"Returns the list of the generations in the form [newer, older] . Example Nebulex.Adapters.Local.Generation . list ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#list/1","title":"Nebulex.Adapters.Local.Generation.list/1","type":"function"},{"doc":"Returns the memory info in a tuple form {used_mem, total_mem} . Example Nebulex.Adapters.Local.Generation . memory_info ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#memory_info/1","title":"Nebulex.Adapters.Local.Generation.memory_info/1","type":"function"},{"doc":"Creates a new cache generation. Once the max number of generations is reached, when a new generation is created, the oldest one is deleted. Options :reset_timer - Indicates if the poll frequency time-out should be reset or not (default: true). Example Nebulex.Adapters.Local.Generation . new ( MyCache ) Nebulex.Adapters.Local.Generation . new ( MyCache , reset_timer : false )","ref":"Nebulex.Adapters.Local.Generation.html#new/2","title":"Nebulex.Adapters.Local.Generation.new/2","type":"function"},{"doc":"Returns the newer generation. Example Nebulex.Adapters.Local.Generation . newer ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#newer/1","title":"Nebulex.Adapters.Local.Generation.newer/1","type":"function"},{"doc":"Reallocates the block of memory that was previously allocated for the given server_ref with the new size . In other words, reallocates the max memory size for a cache generation. Example Nebulex.Adapters.Local.Generation . realloc ( MyCache , 1_000_000 )","ref":"Nebulex.Adapters.Local.Generation.html#realloc/2","title":"Nebulex.Adapters.Local.Generation.realloc/2","type":"function"},{"doc":"Resets the timer for pushing new cache generations. Example Nebulex.Adapters.Local.Generation . reset_timer ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#reset_timer/1","title":"Nebulex.Adapters.Local.Generation.reset_timer/1","type":"function"},{"doc":"Returns the PID of the GC server for the given server_ref . Example Nebulex.Adapters.Local.Generation . server ( MyCache )","ref":"Nebulex.Adapters.Local.Generation.html#server/1","title":"Nebulex.Adapters.Local.Generation.server/1","type":"function"},{"doc":"Starts the garbage collector for the build-in local cache adapter.","ref":"Nebulex.Adapters.Local.Generation.html#start_link/1","title":"Nebulex.Adapters.Local.Generation.start_link/1","type":"function"},{"doc":"","ref":"Nebulex.Adapters.Local.Generation.html#t:opts/0","title":"Nebulex.Adapters.Local.Generation.opts/0","type":"type"},{"doc":"","ref":"Nebulex.Adapters.Local.Generation.html#t:server_ref/0","title":"Nebulex.Adapters.Local.Generation.server_ref/0","type":"type"},{"doc":"","ref":"Nebulex.Adapters.Local.Generation.html#t:t/0","title":"Nebulex.Adapters.Local.Generation.t/0","type":"type"},{"doc":"Adapter module for Multi-level Cache. This is just a simple layer on top of local or distributed cache implementations that enables to have a cache hierarchy by levels. Multi-level caches generally operate by checking the fastest, level 1 (L1) cache first; if it hits, the adapter proceeds at high speed. If that first cache misses, the next fastest cache (level 2, L2) is checked, and so on, before accessing external memory (that can be handled by a cacheable decorator). For write functions, the &quot;Write Through&quot; policy is applied by default; this policy ensures that the data is stored safely as it is written throughout the hierarchy. However, it is possible to force the write operation in a specific level (although it is not recommended) via level option, where the value is a positive integer greater than 0. We can define a multi-level cache as follows: defmodule MyApp.Multilevel do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Multilevel defmodule L1 do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Local end defmodule L2 do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Partitioned end end Where the configuration for the cache and its levels must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.Multilevel , model : :inclusive , levels : [ { MyApp.Multilevel.L1 , gc_interval : :timer . hours ( 12 ) , backend : :shards } , { MyApp.Multilevel.L2 , primary : [ gc_interval : :timer . hours ( 12 ) , backend : :shards ] } ] If your application was generated with a supervisor (by passing --sup to mix new ) you will have a lib/my_app/application.ex file containing the application start callback that defines and starts your supervisor. You just need to edit the start/2 function to start the cache as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { MyApp.Multilevel , [ ] } , ... ] See Nebulex.Cache for more information. Options This adapter supports the following options and all of them can be given via the cache configuration: :levels - This option is to define the levels, a list of tuples {cache_level :: Nebulex.Cache.t(), opts :: Keyword.t()} , where the first element is the module that defines the cache for that level, and the second one is the options that will be passed to that level in the start/link/1 (which depends on the adapter this level is using). The order in which the levels are defined is the same the multi-level cache will use. For example, the first cache in the list will be the L1 cache (level 1) and so on; the Nth element will be the LN cache. This option is mandatory, if it is not set or empty, an exception will be raised. :model - Specifies the cache model: :inclusive or :exclusive ; defaults to :inclusive . In an inclusive cache, the same data can be present in all caches/levels. In an exclusive cache, data can be present in only one cache/level and a key cannot be found in the rest of caches at the same time. This option affects get operation only; if :cache_model is :inclusive , when the key is found in a level N, that entry is duplicated backwards (to all previous levels: 1..N-1). Shared options Almost all of the cache functions outlined in Nebulex.Cache module accept the following options: :level - It may be an integer greater than 0 that specifies the cache level where the operation will take place. By default, the evaluation is performed throughout the whole cache hierarchy (all levels). Telemetry events This adapter emits all recommended Telemetry events, and documented in Nebulex.Cache module (see &quot;Adapter-specific events&quot; section). Since the multi-level adapter is a layer/wrapper on top of other existing adapters, each cache level may Telemetry emit events independently. For example, for the cache defined before MyApp.Multilevel , the next events will be emitted for the main multi-level cache: [:my_app, :multilevel, :command, :start] [:my_app, :multilevel, :command, :stop] [:my_app, :multilevel, :command, :exception] For the L1 (configured with the local adapter): [:my_app, :multilevel, :l1, :command, :start] [:my_app, :multilevel, :l1, :command, :stop] [:my_app, :multilevel, :l1, :command, :exception] For the L2 (configured with the partitioned adapter): [:my_app, :multilevel, :l2, :command, :start] [:my_app, :multilevel, :l2, :primary, :command, :start] [:my_app, :multilevel, :l2, :command, :stop] [:my_app, :multilevel, :l2, :primary, :command, :stop] [:my_app, :multilevel, :l2, :command, :exception] [:my_app, :multilevel, :l2, :primary, :command, :exception] See also the Telemetry guide for more information and examples. Stats Since the multi-level adapter works as a wrapper for the configured cache levels, the support for stats depends on the underlying levels. Also, the measurements are consolidated per level, they are not aggregated. For example, if we enable the stats for the multi-level cache defined previously and run: MyApp.Multilevel . stats ( ) The returned stats will look like: % Nebulex.Stats { measurements : %{ l1 : %{ evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , writes : 0 } , l2 : %{ evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , writes : 0 } } , metadata : %{ l1 : %{ cache : NMyApp.Multilevel.L1 , started_at : ~U[2021-01-10 13:06:04.075084Z] } , l2 : %{ cache : MyApp.Multilevel.L2.Primary , started_at : ~U[2021-01-10 13:06:04.089888Z] } , cache : MyApp.Multilevel , started_at : ~U[2021-01-10 13:06:04.066750Z] } } IMPORTANT: Those cache levels with stats disabled won't be included into the returned stats (they are skipped). If a cache level is using an adapter that does not support stats, you may get unexpected errors. Therefore, and as overall recommendation, check out the documentation for adapters used by the underlying cache levels and ensure they implement the Nebulex.Adapter.Stats behaviour. Stats with Telemetry In case you are using Telemetry metrics, you can define the metrics per level, for example: last_value ( &quot;nebulex.cache.stats.l1.hits&quot; , event_name : &quot;nebulex.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :hits ] ) , tags : [ :cache ] ) last_value ( &quot;nebulex.cache.stats.l1.misses&quot; , event_name : &quot;nebulex.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :misses ] ) , tags : [ :cache ] ) See the section &quot;Instrumenting Multi-level caches&quot; in the Telemetry guide for more information. Extended API This adapter provides one additional convenience function for retrieving the cache model for the given cache name : MyCache . model ( ) MyCache . model ( :cache_name ) Caveats of multi-level adapter Because this adapter reuses other existing/configured adapters, it inherits all their limitations too. Therefore, it is highly recommended to check the documentation of the adapters to use.","ref":"Nebulex.Adapters.Multilevel.html","title":"Nebulex.Adapters.Multilevel","type":"module"},{"doc":"The Nil adapter is a special cache adapter that disables the cache; it loses all the items saved on it and it returns nil for all the read and true for all save operations. This adapter is mostly useful for tests. Example Suppose you have an application using Ecto for database access and Nebulex for caching. Then, you have defined a cache and a repo within it. Since you are using a database, there might be some cases you may want to disable the cache to avoid issues when running the test, for example, in some test cases, when accessing the database you expect no data at all, but you could retrieve the data from cache anyway because maybe it was cached in a previous test. Therefore, you have to delete all entries from the cache before to run each test to make sure the cache is always empty. This is where the Nil adapter comes in, instead of adding code to flush the cache before each test, you could define a test cache using the Nil adapter for the tests. One one hand, you have defined the cache in your application within lib/my_app/cache.ex : defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end And on the other hand, in the tests you have defined the test cache within test/support/test_cache.ex : defmodule MyApp.TestCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Nil end Now, we have to tell the app what cache to use depending on the environment, for tests we want MyApp.TestCache , otherwise it is always MyApp.Cache . We can do this very easy by introducing a new config parameter to decide what cache module to use. For tests you can define the config config/test.exs : config :my_app , nebulex_cache : MyApp.TestCache , ... The final piece is to read the config parameter and start the cache properly. Within lib/my_app/application.ex you could have: def start ( _type , _args ) do children = [ { Application . get_env ( :my_app , :nebulex_cache , MyApp.Cache ) , [ ] } , ] ... As you can see, by default MyApp.Cache is always used, unless the :nebulex_cache option points to a different module, which will be when tests are executed ( :test env).","ref":"Nebulex.Adapters.Nil.html","title":"Nebulex.Adapters.Nil","type":"module"},{"doc":"Built-in adapter for partitioned cache topology. Overall features Partitioned cache topology (Sharding Distribution Model). Configurable primary storage adapter. Configurable Keyslot to distributed the keys across the cluster members. Support for transactions via Erlang global name registration facility. Stats support rely on the primary storage adapter. Partitioned Cache Topology There are several key points to consider about a partitioned cache: Partitioned : The data in a distributed cache is spread out over all the servers in such a way that no two servers are responsible for the same piece of cached data. This means that the size of the cache and the processing power associated with the management of the cache can grow linearly with the size of the cluster. Also, it means that operations against data in the cache can be accomplished with a &quot;single hop,&quot; in other words, involving at most one other server. Load-Balanced : Since the data is spread out evenly over the servers, the responsibility for managing the data is automatically load-balanced across the cluster. Ownership : Exactly one node in the cluster is responsible for each piece of data in the cache. Point-To-Point : The communication for the partitioned cache is all point-to-point, enabling linear scalability. Location Transparency : Although the data is spread out across cluster nodes, the exact same API is used to access the data, and the same behavior is provided by each of the API methods. This is called location transparency, which means that the developer does not have to code based on the topology of the cache, since the API and its behavior will be the same with a local cache, a replicated cache, or a distributed cache. Failover : Failover of a distributed cache involves promoting backup data to be primary storage. When a cluster node fails, all remaining cluster nodes determine what data each holds in backup that the failed cluster node had primary responsible for when it died. Those data becomes the responsibility of whatever cluster node was the backup for the data. However, this adapter does not provide fault-tolerance implementation, each piece of data is kept in a single node/machine (via sharding), then, if a node fails, the data kept by this node won't be available for the rest of the cluster memebers. Based on &quot;Distributed Caching Essential Lessons&quot; by Cameron Purdy and Coherence Partitioned Cache Service . Additional implementation notes :pg2 or :pg (&gt;= OTP 23) is used under-the-hood by the adapter to manage the cluster nodes. When the partitioned cache is started in a node, it creates a group and joins it (the cache supervisor PID is joined to the group). Then, when a function is invoked, the adapter picks a node from the group members, and then the function is executed on that specific node. In the same way, when a partitioned cache supervisor dies (the cache is stopped or killed for some reason), the PID of that process is automatically removed from the PG group; this is why it's recommended to use consistent hashing for distributing the keys across the cluster nodes. NOTE: pg2 will be replaced by pg in future, since the pg2 module is deprecated as of OTP 23 and scheduled for removal in OTP 24. This adapter depends on a local cache adapter (primary storage), it adds a thin layer on top of it in order to distribute requests across a group of nodes, where is supposed the local cache is running already. However, you don't need to define any additional cache module for the primary storage, instead, the adapter initializes it automatically (it adds the primary storage as part of the supervision tree) based on the given options within the primary_storage_adapter: argument. Usage When used, the Cache expects the :otp_app and :adapter as options. The :otp_app should point to an OTP application that has the cache configuration. For example: defmodule MyApp.PartitionedCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Partitioned end Optionally, you can configure the desired primary storage adapter with the option :primary_storage_adapter ; defaults to Nebulex.Adapters.Local . defmodule MyApp.PartitionedCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Partitioned , primary_storage_adapter : Nebulex.Adapters.Local end Also, you can provide a custom keyslot function: defmodule MyApp.PartitionedCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Partitioned , primary_storage_adapter : Nebulex.Adapters.Local @behaviour Nebulex.Adapter.Keyslot @impl true def hash_slot ( key , range ) do key |&gt; :erlang . phash2 ( ) |&gt; :jchash . compute ( range ) end end Where the configuration for the cache must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.PartitionedCache , keyslot : MyApp.PartitionedCache , primary : [ gc_interval : 3_600_000 , backend : :shards ] If your application was generated with a supervisor (by passing --sup to mix new ) you will have a lib/my_app/application.ex file containing the application start callback that defines and starts your supervisor. You just need to edit the start/2 function to start the cache as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { MyApp.PartitionedCache , [ ] } , ... ] See Nebulex.Cache for more information. Options This adapter supports the following options and all of them can be given via the cache configuration: :primary - The options that will be passed to the adapter associated with the local primary storage. These options will depend on the local adapter to use. :keyslot - Defines the module implementing Nebulex.Adapter.Keyslot behaviour. :task_supervisor_opts - Start-time options passed to Task.Supervisor.start_link/1 when the adapter is initialized. :join_timeout - Interval time in milliseconds for joining the running partitioned cache to the cluster. This is to ensure it is always joined. Defaults to :timer.seconds(180) . Shared options Almost all of the cache functions outlined in Nebulex.Cache module accept the following options: :timeout - The time-out value in milliseconds for the command that will be executed. If the timeout is exceeded, then the current process will exit. For executing a command on remote nodes, this adapter uses Task.await/2 internally for receiving the result, so this option tells how much time the adapter should wait for it. If the timeout is exceeded, the task is shut down but the current process doesn't exit, only the result associated with that task is skipped in the reduce phase. Telemetry events This adapter emits all recommended Telemetry events, and documented in Nebulex.Cache module (see &quot;Adapter-specific events&quot; section). Since the partitioned adapter depends on the configured primary storage adapter (local cache adapter), this one may also emit Telemetry events. Therefore, there will be events emitted by the partitioned adapter as well as the primary storage adapter. For example, for the cache defined before MyApp.PartitionedCache , these would be the emitted events: [:my_app, :partitioned_cache, :command, :start] [:my_app, :partitioned_cache, :primary, :command, :start] [:my_app, :partitioned_cache, :command, :stop] [:my_app, :partitioned_cache, :primary, :command, :stop] [:my_app, :partitioned_cache, :command, :exception] [:my_app, :partitioned_cache, :primary, :command, :exception] As you may notice, the telemetry prefix by default for the partitioned cache is [:my_app, :partitioned_cache] , and the prefix for its primary storage [:my_app, :partitioned_cache, :primary] . See also the Telemetry guide for more information and examples. Adapter-specific telemetry events This adapter exposes following Telemetry events: telemetry_prefix ++ [:bootstrap, :started] - Dispatched by the adapter when the bootstrap process is started. Measurements: %{system_time: non_neg_integer} Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , cluster_nodes : [ node ] } telemetry_prefix ++ [:bootstrap, :stopped] - Dispatched by the adapter when the bootstrap process is stopped. Measurements: %{system_time: non_neg_integer} Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , cluster_nodes : [ node ] , reason : term } telemetry_prefix ++ [:bootstrap, :exit] - Dispatched by the adapter when the bootstrap has received an exit signal. Measurements: %{system_time: non_neg_integer} Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , cluster_nodes : [ node ] , reason : term } telemetry_prefix ++ [:bootstrap, :joined] - Dispatched by the adapter when the bootstrap has joined the cache to the cluster. Measurements: %{system_time: non_neg_integer} Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , cluster_nodes : [ node ] } Stats This adapter depends on the primary storage adapter for the stats support. Therefore, it is important to ensure the underlying primary storage adapter does support stats, otherwise, you may get unexpected errors. Extended API This adapter provides some additional convenience functions to the Nebulex.Cache API. Retrieving the primary storage or local cache module: MyCache . __primary__ ( ) Retrieving the cluster nodes associated with the given cache name : MyCache . nodes ( ) Get a cluster node based on the given key : MyCache . get_node ( &quot;mykey&quot; ) Joining the cache to the cluster: MyCache . join_cluster ( ) Leaving the cluster (removes the cache from the cluster): MyCache . leave_cluster ( ) Caveats of partitioned adapter For Nebulex.Cache.get_and_update/3 and Nebulex.Cache.update/4 , they both have a parameter that is the anonymous function, and it is compiled into the module where it is created, which means it necessarily doesn't exists on remote nodes. To ensure they work as expected, you must provide functions from modules existing in all nodes of the group.","ref":"Nebulex.Adapters.Partitioned.html","title":"Nebulex.Adapters.Partitioned","type":"module"},{"doc":"","ref":"Nebulex.Adapters.Partitioned.html#do_put_all/4","title":"Nebulex.Adapters.Partitioned.do_put_all/4","type":"function"},{"doc":"Helper to perform stream/3 locally.","ref":"Nebulex.Adapters.Partitioned.html#eval_stream/3","title":"Nebulex.Adapters.Partitioned.eval_stream/3","type":"function"},{"doc":"Helper function to use dynamic cache for internal primary cache storage when needed.","ref":"Nebulex.Adapters.Partitioned.html#with_dynamic_cache/3","title":"Nebulex.Adapters.Partitioned.with_dynamic_cache/3","type":"function"},{"doc":"Built-in adapter for replicated cache topology. Overall features Replicated cache topology. Configurable primary storage adapter. Cache-level locking when deleting all entries or adding new nodes. Key-level (or entry-level) locking for key-based write-like operations. Support for transactions via Erlang global name registration facility. Stats support rely on the primary storage adapter. Replicated Cache Topology A replicated cache is a clustered, fault tolerant cache where data is fully replicated to every member in the cluster. This cache offers the fastest read performance with linear performance scalability for reads but poor scalability for writes (as writes must be processed by every member in the cluster). Because data is replicated to all servers, adding servers does not increase aggregate cache capacity. There are several challenges to building a reliably replicated cache. The first is how to get it to scale and perform well. Updates to the cache have to be sent to all cluster nodes, and all cluster nodes have to end up with the same data, even if multiple updates to the same piece of data occur at the same time. Also, if a cluster node requests a lock, ideally it should not have to get all cluster nodes to agree on the lock or at least do it in a very efficient way ( :global is used here), otherwise it will scale extremely poorly; yet in the case of a cluster node failure, all of the data and lock information must be kept safely. The best part of a replicated cache is its access speed. Since the data is replicated to each cluster node, it is available for use without any waiting. This is referred to as &quot;zero latency access,&quot; and is perfect for situations in which an application requires the highest possible speed in its data access. However, there are some limitations: Cost Per Update - Updating a replicated cache requires pushing the new version of the data to all other cluster members, which will limit scalability if there is a high frequency of updates per member. Cost Per Entry - The data is replicated to every cluster member, so Memory Heap space is used on each member, which will impact performance for large caches. Based on &quot;Distributed Caching Essential Lessons&quot; by Cameron Purdy . Usage When used, the Cache expects the :otp_app and :adapter as options. The :otp_app should point to an OTP application that has the cache configuration. For example: defmodule MyApp.ReplicatedCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Replicated end Optionally, you can configure the desired primary storage adapter with the option :primary_storage_adapter ; defaults to Nebulex.Adapters.Local . defmodule MyApp.ReplicatedCache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Replicated , primary_storage_adapter : Nebulex.Adapters.Local end The configuration for the cache must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.ReplicatedCache , primary : [ gc_interval : 3_600_000 , backend : :shards ] If your application was generated with a supervisor (by passing --sup to mix new ) you will have a lib/my_app/application.ex file containing the application start callback that defines and starts your supervisor. You just need to edit the start/2 function to start the cache as a supervisor on your application's supervisor: def start ( _type , _args ) do children = [ { MyApp.ReplicatedCache , [ ] } , ... ] See Nebulex.Cache for more information. Options This adapter supports the following options and all of them can be given via the cache configuration: :primary - The options that will be passed to the adapter associated with the local primary storage. These options will depend on the local adapter to use. :task_supervisor_opts - Start-time options passed to Task.Supervisor.start_link/1 when the adapter is initialized. Shared options Almost all of the cache functions outlined in Nebulex.Cache module accept the following options: :timeout - The time-out value in milliseconds for the command that will be executed. If the timeout is exceeded, then the current process will exit. For executing a command on remote nodes, this adapter uses Task.await/2 internally for receiving the result, so this option tells how much time the adapter should wait for it. If the timeout is exceeded, the task is shut down but the current process doesn't exit, only the result associated with that task is skipped in the reduce phase. Telemetry events This adapter emits all recommended Telemetry events, and documented in Nebulex.Cache module (see &quot;Adapter-specific events&quot; section). Since the replicated adapter depends on the configured primary storage adapter (local cache adapter), this one may also emit Telemetry events. Therefore, there will be events emitted by the replicated adapter as well as the primary storage adapter. For example, for the cache defined before MyApp.ReplicatedCache , these would be the emitted events: [:my_app, :replicated_cache, :command, :start] [:my_app, :replicated_cache, :primary, :command, :start] [:my_app, :replicated_cache, :command, :stop] [:my_app, :replicated_cache, :primary, :command, :stop] [:my_app, :replicated_cache, :command, :exception] [:my_app, :replicated_cache, :primary, :command, :exception] As you may notice, the telemetry prefix by default for the replicated cache is [:my_app, :replicated_cache] , and the prefix for its primary storage [:my_app, :replicated_cache, :primary] . See also the Telemetry guide for more information and examples. Stats This adapter depends on the primary storage adapter for the stats support. Therefore, it is important to ensure the underlying primary storage adapter does support stats, otherwise, you may get unexpected errors. Extended API This adapter provides some additional convenience functions to the Nebulex.Cache API. Retrieving the primary storage or local cache module: MyCache . __primary__ ( ) Retrieving the cluster nodes associated with the given cache name: MyCache . nodes ( ) Joining the cache to the cluster: MyCache . join_cluster ( ) Leaving the cluster (removes the cache from the cluster): MyCache . leave_cluster ( ) Adapter-specific telemetry events This adapter exposes following Telemetry events: telemetry_prefix ++ [:replication] - Dispatched by the adapter when a replication error occurs due to a write-like operation under-the-hood. Measurements: %{rpc_errors: non_neg_integer} Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , rpc_errors : [ { node , error :: term } ] } telemetry_prefix ++ [:bootstrap] - Dispatched by the adapter at start time when there are errors while synching up with the cluster nodes. Measurements: %{ failed_nodes : non_neg_integer , remote_errors : non_neg_integer } Metadata: %{ adapter_meta : %{ optional ( atom ) =&gt; term } , failed_nodes : [ node ] , remote_errors : [ term ] } Caveats of replicated adapter As it is explained in the beginning, a replicated topology not only brings with advantages (mostly for reads) but also with some limitations and challenges. This adapter uses global locks (via :global ) for all operation that modify or alter the cache somehow to ensure as much consistency as possible across all members of the cluster. These locks may be per key or for the entire cache depending on the operation taking place. For that reason, it is very important to be aware about those operation that can potentally lead to performance and scalability issues, so that you can do a better usage of the replicated adapter. The following is with the operations and aspects you should pay attention to: Starting and joining a new replicated node to the cluster is the most expensive action, because all write-like operations across all members of the cluster are blocked until the new node completes the synchronization process, which involves copying cached data from any of the existing cluster nodes into the new node, and this could be very expensive depending on the number of caches entries. For that reason, adding new nodes is considered an expensive operation that should happen only from time to time. Deleting all entries. When Nebulex.Cache.delete_all/2 action is executed, like in the previous case, all write-like operations in all members of the cluster are blocked until the deletion action is completed (this implies deleting all cached data from all cluster nodes). Therefore, deleting all entries from cache is also considered an expensive operation that should happen only from time to time. Write-like operations based on a key only block operations related to that key across all members of the cluster. This is not as critical as the previous two cases but it is something to keep in mind anyway because if there is a highly demanded key in terms of writes, that could be also a potential bottleneck. Summing up, the replicated cache topology along with this adapter should be used mainly when the the reads clearly dominate over the writes (e.g.: Reads 80% and Writes 20% or less). Besides, operations like deleting all entries from cache or adding new nodes must be executed only once in a while to avoid performance issues, since they are very expensive.","ref":"Nebulex.Adapters.Replicated.html","title":"Nebulex.Adapters.Replicated","type":"module"},{"doc":"Helper function to use dynamic cache for internal primary cache storage when needed.","ref":"Nebulex.Adapters.Replicated.html#with_dynamic_cache/3","title":"Nebulex.Adapters.Replicated.with_dynamic_cache/3","type":"function"},{"doc":"Cache's main interface; defines the cache abstraction layer which is highly inspired by Ecto . A Cache maps to an underlying implementation, controlled by the adapter. For example, Nebulex ships with a default adapter that implements a local generational cache. When used, the Cache expects the :otp_app and :adapter as options. The :otp_app should point to an OTP application that has the cache configuration. For example, the Cache: defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end Could be configured with: config :my_app , MyApp.Cache , backend : :shards , gc_interval : :timer . hours ( 12 ) , max_size : 1_000_000 , allocated_memory : 2_000_000_000 , gc_cleanup_min_timeout : :timer . seconds ( 10 ) , gc_cleanup_max_timeout : :timer . minutes ( 10 ) Most of the configuration that goes into the config is specific to the adapter. For this particular example, you can check Nebulex.Adapters.Local for more information. In spite of this, the following configuration values are shared across all adapters: :name - The name of the Cache supervisor process. :telemetry_prefix - It is recommend for adapters to publish events using the Telemetry library. By default, the telemetry prefix is based on the module name, so if your module is called MyApp.Cache , the prefix will be [:my_app, :cache] . See the &quot;Telemetry events&quot; section to see what events recommended for the adapters to publish.. Note that if you have multiple caches, you should keep the :telemetry_prefix consistent for each of them and use the :cache and/or :name (in case of a named or dynamic cache) properties in the event metadata for distinguishing between caches. :telemetry - An optional flag to tell the adapters whether Telemetry events should be emitted or not. Defaults to true . :stats - Boolean to define whether or not the cache will provide stats. Defaults to false . Each adapter is responsible for providing stats by implementing Nebulex.Adapter.Stats behaviour. See the &quot;Stats&quot; section below. Telemetry events Similar to Ecto or Phoenix, Nebulex also provides built-in Telemetry events applied to all caches, and cache adapter-specific events. Nebulex built-in events The following events are emitted by all Nebulex caches: [:nebulex, :cache, :init] - it is dispatched whenever a cache starts. The measurement is a single system_time entry in native unit. The metadata is the :cache and all initialization options under :opts . Adapter-specific events It is recommend the adapters to publish certain Telemetry events listed below. Those events will use the :telemetry_prefix outlined above which defaults to [:my_app, :cache] . For instance, to receive all events published by a cache called MyApp.Cache , one could define a module: defmodule MyApp.Telemetry do def handle_event ( [ :my_app , :cache , :command , event ] , measurements , metadata , config ) do case event do :start -&gt; # Handle start event ... :stop -&gt; # Handle stop event ... :exception -&gt; # Handle exception event ... end end end Then, in the Application.start/2 callback, attach the handler to this event using a unique handler id: :telemetry . attach ( &quot;my-app-handler-id&quot; , [ :my_app , :cache , :command ] , &amp; MyApp.Telemetry . handle_event / 4 , %{ } ) See the telemetry documentation for more information. The following are the events you should expect from Nebulex. All examples below consider a cache named MyApp.Cache : [:my_app, :cache, :command, :start] This event should be invoked on every cache call sent to the adapter before the command logic is executed. The :measurements map will include the following: :system_time - The current system time in native units from calling: System.system_time() . A Telemetry :metadata map including the following fields. Each cache adapter may emit different information here. For built-in adapters, it will contain: :adapter_meta - The adapter metadata. :function_name - The name of the invoked adapter function. :args - The arguments of the invoked adapter function, omitting the first argument, since it is the adapter metadata already included into the event's metadata. [:my_app, :cache, :command, :stop] This event should be invoked on every cache call sent to the adapter after the command logic is executed. The :measurements map will include the following: :duration - The time spent executing the cache command. The measurement is given in the :native time unit. You can read more about it in the docs for System.convert_time_unit/3 . A Telemetry :metadata map including the following fields. Each cache adapter may emit different information here. For built-in adapters, it will contain: :adapter_meta - The adapter metadata. :function_name - The name of the invoked adapter function. :args - The arguments of the invoked adapter function, omitting the first argument, since it is the adapter metadata already included into the event's metadata. :result - The command result. [:my_app, :cache, :command, :exception] This event should be invoked when an error or exception occurs while executing the cache command. The :measurements map will include the following: :duration - The time spent executing the cache command. The measurement is given in the :native time unit. You can read more about it in the docs for System.convert_time_unit/3 . A Telemetry :metadata map including the following fields. Each cache adapter may emit different information here. For built-in adapters, it will contain: :adapter_meta - The adapter metadata. :function_name - The name of the invoked adapter function. :args - The arguments of the invoked adapter function, omitting the first argument, since it is the adapter metadata already included into the event's metadata. :kind - The type of the error: :error , :exit , or :throw . :reason - The reason of the error. :stacktrace - The stacktrace. NOTE: The events outlined above are the recommended for the adapters to dispatch. However, it is highly recommended to review the used adapter documentation to ensure it is fullly compatible with these events, perhaps differences, or perhaps also additional events. Stats Stats are provided by the adapters by implementing the optional behaviour Nebulex.Adapter.Stats . This behaviour exposes a callback to return the current cache stats. Nevertheless, the behaviour brings with a default implementation using Erlang counters , which is used by the local built-in adapter ( Nebulex.Adapters.Local ). One can enable the stats by setting the option :stats to true . For example, in the configuration file: config :my_app , MyApp.Cache , stats : true , ... Remember to check if the underlying adapter implements the Nebulex.Adapter.Stats behaviour. See Nebulex.Cache.stats/0 for more information. Dispatching stats via Telemetry It is possible to emit Telemetry events for the current stats via Nebulex.Cache.dispatch_stats/1 , but it has to be invoked explicitly; Nebulex does not emit this Telemetry event automatically. But it is very easy to emit this event using :telemetry_poller . For example, one can define a custom pollable measurement: :telemetry_poller . start_link ( measurements : [ { MyApp.Cache , :dispatch_stats , [ ] } , ] , # configure sampling period - default is :timer.seconds(5) period : :timer . seconds ( 30 ) , name : :my_cache_stats_poller ) Or you can also start the :telemetry_poller process along with your application supervision tree: def start ( _type , _args ) do my_cache_stats_poller_opts = [ measurements : [ { MyApp.Cache , :dispatch_stats , [ ] } , ] , period : :timer . seconds ( 30 ) , name : :my_cache_stats_poller ] children = [ { MyApp.Cache , [ ] } , { :telemetry_poller , my_cache_stats_poller_opts } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end See Nebulex Telemetry Guide for more information. Distributed topologies Nebulex provides the following adapters for distributed topologies: Nebulex.Adapters.Partitioned - Partitioned cache topology. Nebulex.Adapters.Replicated - Replicated cache topology. Nebulex.Adapters.Multilevel - Multi-level distributed cache topology. These adapters work more as wrappers for an existing local adapter and provide the distributed topology on top of it. Optionally, you can set the adapter for the primary cache storage with the option :primary_storage_adapter . Defaults to Nebulex.Adapters.Local .","ref":"Nebulex.Cache.html","title":"Nebulex.Cache","type":"behaviour"},{"doc":"Returns the adapter tied to the cache.","ref":"Nebulex.Cache.html#c:__adapter__/0","title":"Nebulex.Cache.__adapter__/0","type":"callback"},{"doc":"Returns the default key generator applied only when using &quot;declarative annotation-based caching&quot; via Nebulex.Caching . Sometimes you may want to set a different key generator when using declarative caching. By default, the key generator is set to Nebulex.Caching.SimpleKeyGenerator . You can change the default key generator at compile time with: use Nebulex.Cache , default_key_generator : MyKeyGenerator See Nebulex.Caching and Nebulex.Caching.KeyGenerator for more information.","ref":"Nebulex.Cache.html#c:__default_key_generator__/0","title":"Nebulex.Cache.__default_key_generator__/0","type":"callback"},{"doc":"Fetches all entries from cache matching the given query . May raise Nebulex.QueryError if query validation fails. Query values There are two types of query values. The ones shared and implemented by all adapters and the ones that are adapter specific. Common queries The following query values are shared and/or supported for all adapters: nil - Returns a list with all cached entries based on the :return option. Adapter-specific queries The query value depends entirely on the adapter implementation; it could any term. Therefore, it is highly recommended to see adapters' documentation for more information about building queries. For example, the built-in Nebulex.Adapters.Local adapter uses :ets.match_spec() for queries, as well as other pre-defined ones like :unexpired and :expired . Options :return - Tells the query what to return from the matched entries. See the possible values in the &quot;Query return option&quot; section below. The default depends on the adapter, for example, the default for the built-in adapters is :key . This option is supported by the build-in adapters, but it is recommended to see the adapter's documentation to confirm its compatibility with this option. See the &quot;Shared options&quot; section at the module documentation for more options. Query return option The following are the possible values for the :return option: :key - Returns a list only with the keys. :value - Returns a list only with the values. :entry - Returns a list of Nebulex.Entry.t/0 . {:key, :value} - Returns a list of tuples in the form {key, value} . See adapters documentation to confirm what of these options are supported and what other added. Example Populate the cache with some entries: iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . put ( &amp;1 , &amp;1 * 2 ) ) Fetch all (with default params): iex&gt; MyCache . all ( ) [ 1 , 2 , 3 , 4 , 5 ] Fetch all entries and return values: iex&gt; MyCache . all ( nil , return : :value ) [ 2 , 4 , 6 , 8 , 10 ] Fetch all entries and return them as key/value pairs: iex&gt; MyCache . all ( nil , return : { :key , :value } ) [ { 1 , 2 } , { 2 , 4 } , { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ] Fetch all entries that match with the given query assuming we are using Nebulex.Adapters.Local adapter: iex&gt; query = [ { { :_ , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 5 } ] , [ :&quot;$1&quot; ] } ] iex&gt; MyCache . all ( query ) [ 3 , 4 , 5 ] Query Query spec is defined by the adapter, hence, it is recommended to review adapters documentation. For instance, the built-in Nebulex.Adapters.Local adapter supports nil | :unexpired | :expired | :ets.match_spec() as query value. Examples Additional built-in queries for Nebulex.Adapters.Local adapter: iex&gt; unexpired = MyCache . all ( :unexpired ) iex&gt; expired = MyCache . all ( :expired ) If we are using Nebulex.Adapters.Local adapter, the stored entry tuple {:entry, key, value, touched, ttl} , then the match spec could be something like: iex&gt; spec = [ ...&gt; { { :entry , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , ...&gt; [ { :&gt; , :&quot;$2&quot; , 5 } ] , [ { { :&quot;$1&quot; , :&quot;$2&quot; } } ] } ...&gt; ] iex&gt; MyCache . all ( spec ) [ { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ] The same previous query but using Ex2ms : iex&gt; import Ex2ms Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { _ . key , value , _ , _ } when value &gt; 5 -&gt; { key , value } ...&gt; end iex&gt; MyCache . all ( spec ) [ { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ]","ref":"Nebulex.Cache.html#c:all/2","title":"Nebulex.Cache.all/2","type":"callback"},{"doc":"Returns the adapter configuration stored in the :otp_app environment. If the init/1 callback is implemented in the cache, it will be invoked.","ref":"Nebulex.Cache.html#c:config/0","title":"Nebulex.Cache.config/0","type":"callback"},{"doc":"Counts all entries in cache matching the given query . It returns the count of the matched entries. If query is nil (the default), then the total number of cached entries is returned. May raise Nebulex.QueryError if query validation fails. Query values See all/2 callback for more information about the query values. Example Populate the cache with some entries: iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . put ( &amp;1 , &amp;1 * 2 ) ) Count all entries in cache: iex&gt; MyCache . count_all ( ) 5 Count all entries that match with the given query assuming we are using Nebulex.Adapters.Local adapter: iex&gt; query = [ { { :_ , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 5 } ] , [ true ] } ] iex&gt; MyCache . count_all ( query ) For the local adapter you can use Ex2ms to build the match specs much easier. Additional built-in queries for Nebulex.Adapters.Local adapter: iex&gt; unexpired = MyCache . count_all ( :unexpired ) iex&gt; expired = MyCache . count_all ( :expired )","ref":"Nebulex.Cache.html#c:count_all/2","title":"Nebulex.Cache.count_all/2","type":"callback"},{"doc":"Decrements the counter stored at key by the given amount . If amount &lt; 0 (negative), the value is incremented by that amount instead (opposite to incr/3 ). Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . :default - If key is not present in Cache, the default value is inserted as initial value of key before the it is incremented. Defaults to 0 . See the &quot;Shared options&quot; section at the module documentation for more options. Examples iex&gt; MyCache . decr ( :a ) - 1 iex&gt; MyCache . decr ( :a , 2 ) - 3 iex&gt; MyCache . decr ( :a , - 1 ) - 2 iex&gt; MyCache . decr ( :missing_key , 2 , default : 10 ) 8","ref":"Nebulex.Cache.html#c:decr/3","title":"Nebulex.Cache.decr/3","type":"callback"},{"doc":"Deletes the entry in Cache for a specific key . Options See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put ( :a , 1 ) :ok iex&gt; MyCache . delete ( :a ) :ok iex&gt; MyCache . get ( :a ) :ok iex&gt; MyCache . delete ( :non_existent_key ) :ok","ref":"Nebulex.Cache.html#c:delete/2","title":"Nebulex.Cache.delete/2","type":"callback"},{"doc":"Deletes all entries matching the given query . If query is nil , then all entries in the cache are deleted. It returns the number of deleted entries. May raise Nebulex.QueryError if query validation fails. Query values See all/2 callback for more information about the query values. Options See the &quot;Shared options&quot; section at the module documentation for more options. Example Populate the cache with some entries: iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . put ( &amp;1 , &amp;1 * 2 ) ) Delete all (with default params): iex&gt; MyCache . delete_all ( ) 5 Delete all entries that match with the given query assuming we are using Nebulex.Adapters.Local adapter: iex&gt; query = [ { { :_ , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 5 } ] , [ true ] } ] iex&gt; MyCache . delete_all ( query ) For the local adapter you can use Ex2ms to build the match specs much easier. Additional built-in queries for Nebulex.Adapters.Local adapter: iex&gt; unexpired = MyCache . delete_all ( :unexpired ) iex&gt; expired = MyCache . delete_all ( :expired )","ref":"Nebulex.Cache.html#c:delete_all/2","title":"Nebulex.Cache.delete_all/2","type":"callback"},{"doc":"Emits a telemetry event when called with the current stats count. The telemetry :measurements map will include the same as Nebulex.Stats.t() 's measurements. For example: :evictions - Current evictions count. :expirations - Current expirations count. :hits - Current hits count. :misses - Current misses count. :updates - Current updates count. :writes - Current writes count. The telemetry :metadata map will include the same as Nebulex.Stats.t() 's metadata by default. For example: :cache - The cache module, or the name (if an explicit name has been given to the cache). Additionally, you can add your own metadata fields by given the option :metadata . Options :event_prefix – The prefix of the telemetry event. Defaults to [:nebulex, :cache] . :metadata – A map with additional metadata fields. Defaults to %{} . Examples iex&gt; MyCache . dispatch_stats ( ) :ok iex&gt; MyCache.Stats . dispatch_stats ( ...&gt; event_prefix : [ :my_cache ] , ...&gt; metadata : %{ tag : &quot;tag1&quot; } ...&gt; ) :ok NOTE: Since :telemetry is an optional dependency, when it is not defined, a default implementation is provided without any logic, just returning :ok .","ref":"Nebulex.Cache.html#c:dispatch_stats/1","title":"Nebulex.Cache.dispatch_stats/1","type":"callback"},{"doc":"Dumps a cache to the given file path . Returns :ok if successful, or {:error, reason} if an error occurs. Options This operation relies entirely on the adapter implementation, which means the options depend on each of them. For that reason, it is recommended to review the documentation of the adapter to be used. The built-in adapters inherit the default implementation from Nebulex.Adapter.Persistence , hence, review the available options there. Examples Populate the cache with some entries: iex&gt; entries = for x &lt;- 1 .. 10 , into : %{ } , do : { x , x } iex&gt; MyCache . set_many ( entries ) :ok Dump cache to a file: iex&gt; MyCache . dump ( &quot;my_cache&quot; ) :ok","ref":"Nebulex.Cache.html#c:dump/2","title":"Nebulex.Cache.dump/2","type":"callback"},{"doc":"Returns true if the given key exists and the new ttl was successfully updated, otherwise, false is returned. Examples iex&gt; MyCache . put ( :a , 1 ) :ok iex&gt; MyCache . expire ( :a , 5 ) true iex&gt; MyCache . expire ( :a , :infinity ) true iex&gt; MyCache . ttl ( :b , 5 ) false","ref":"Nebulex.Cache.html#c:expire/2","title":"Nebulex.Cache.expire/2","type":"callback"},{"doc":"Flushes the cache and returns the number of evicted keys. Examples iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . put ( &amp;1 , &amp;1 ) ) iex&gt; MyCache . flush ( ) 5 iex&gt; MyCache . size ( ) 0","ref":"Nebulex.Cache.html#c:flush/0","title":"Nebulex.Cache.flush/0","type":"callback"},{"doc":"Similar to get/2 but raises KeyError if key is not found. Options See the &quot;Shared options&quot; section at the module documentation for more options. Example MyCache . get! ( :a )","ref":"Nebulex.Cache.html#c:get!/2","title":"Nebulex.Cache.get!/2","type":"callback"},{"doc":"Gets a value from Cache where the key matches the given key . Returns nil if no result was found. Options See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; ) :ok iex&gt; MyCache . get ( &quot;foo&quot; ) &quot;bar&quot; iex&gt; MyCache . get ( :non_existent_key ) nil","ref":"Nebulex.Cache.html#c:get/2","title":"Nebulex.Cache.get/2","type":"callback"},{"doc":"Returns a map with all the key-value pairs in the Cache where the key is in keys . If keys contains keys that are not in the Cache, they're simply ignored. Options See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put_all ( [ a : 1 , c : 3 ] ) :ok iex&gt; MyCache . get_all ( [ :a , :b , :c ] ) %{ a : 1 , c : 3 }","ref":"Nebulex.Cache.html#c:get_all/2","title":"Nebulex.Cache.get_all/2","type":"callback"},{"doc":"Gets the value from key and updates it, all in one pass. fun is called with the current cached value under key (or nil if key hasn't been cached) and must return a two-element tuple: the current value (the retrieved value, which can be operated on before being returned) and the new value to be stored under key . fun may also return :pop , which means the current value shall be removed from Cache and returned. The returned value is a tuple with the current value returned by fun and the new updated value under key . Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Examples Update nonexistent key: iex&gt; MyCache . get_and_update ( :a , fn current_value -&gt; ...&gt; { current_value , &quot;value!&quot; } ...&gt; end ) { nil , &quot;value!&quot; } Update existing key: iex&gt; MyCache . get_and_update ( :a , fn current_value -&gt; ...&gt; { current_value , &quot;new value!&quot; } ...&gt; end ) { &quot;value!&quot; , &quot;new value!&quot; } Pop/remove value if exist: iex&gt; MyCache . get_and_update ( :a , fn _ -&gt; :pop end ) { &quot;new value!&quot; , nil } Pop/remove nonexistent key: iex&gt; MyCache . get_and_update ( :b , fn _ -&gt; :pop end ) { nil , nil }","ref":"Nebulex.Cache.html#c:get_and_update/3","title":"Nebulex.Cache.get_and_update/3","type":"callback"},{"doc":"Returns the atom name or pid of the current cache (based on Ecto dynamic repo). See also put_dynamic_cache/1 .","ref":"Nebulex.Cache.html#c:get_dynamic_cache/0","title":"Nebulex.Cache.get_dynamic_cache/0","type":"callback"},{"doc":"Returns whether the given key exists in the Cache. Examples iex&gt; MyCache . put ( :a , 1 ) :ok iex&gt; MyCache . has_key? ( :a ) true iex&gt; MyCache . has_key? ( :b ) false","ref":"Nebulex.Cache.html#c:has_key?/1","title":"Nebulex.Cache.has_key?/1","type":"callback"},{"doc":"Returns true if the current process is inside a transaction. Examples MyCache . in_transaction? #=&gt; false MyCache . transaction ( fn -&gt; MyCache . in_transaction? #=&gt; true end )","ref":"Nebulex.Cache.html#c:in_transaction?/0","title":"Nebulex.Cache.in_transaction?/0","type":"callback"},{"doc":"Increments the counter stored at key by the given amount . If amount &lt; 0 (negative), the value is decremented by that amount instead. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . :default - If key is not present in Cache, the default value is inserted as initial value of key before the it is incremented. Defaults to 0 . See the &quot;Shared options&quot; section at the module documentation for more options. Examples iex&gt; MyCache . incr ( :a ) 1 iex&gt; MyCache . incr ( :a , 2 ) 3 iex&gt; MyCache . incr ( :a , - 1 ) 2 iex&gt; MyCache . incr ( :missing_key , 2 , default : 10 ) 12","ref":"Nebulex.Cache.html#c:incr/3","title":"Nebulex.Cache.incr/3","type":"callback"},{"doc":"A callback executed when the cache starts or when configuration is read.","ref":"Nebulex.Cache.html#c:init/1","title":"Nebulex.Cache.init/1","type":"callback"},{"doc":"Loads a dumped cache from the given path . Returns :ok if successful, or {:error, reason} if an error occurs. Options Similar to dump/2 , this operation relies entirely on the adapter implementation, therefore, it is recommended to review the documentation of the adapter to be used. Similarly, the built-in adapters inherit the default implementation from Nebulex.Adapter.Persistence , hence, review the available options there. Examples Populate the cache with some entries: iex&gt; entries = for x &lt;- 1 .. 10 , into : %{ } , do : { x , x } iex&gt; MyCache . set_many ( entries ) :ok Dump cache to a file: iex&gt; MyCache . dump ( &quot;my_cache&quot; ) :ok Load the cache from a file: iex&gt; MyCache . load ( &quot;my_cache&quot; ) :ok","ref":"Nebulex.Cache.html#c:load/2","title":"Nebulex.Cache.load/2","type":"callback"},{"doc":"Puts the given value under key into the Cache. If key already holds an entry, it is overwritten. Any previous time to live associated with the key is discarded on successful put operation. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; ) :ok If the value is nil, then it is not stored (operation is skipped): iex&gt; MyCache . put ( &quot;foo&quot; , nil ) :ok Put key with time-to-live: iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; , ttl : 10_000 ) :ok Using Nebulex.Time for TTL: iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; , ttl : :timer . hours ( 1 ) ) :ok iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; , ttl : :timer . minutes ( 1 ) ) :ok iex&gt; MyCache . put ( &quot;foo&quot; , &quot;bar&quot; , ttl : :timer . seconds ( 1 ) ) :ok","ref":"Nebulex.Cache.html#c:put/3","title":"Nebulex.Cache.put/3","type":"callback"},{"doc":"Puts the given entries (key/value pairs) into the Cache. It replaces existing values with new values (just as regular put ). Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put_all ( apples : 3 , bananas : 1 ) :ok iex&gt; MyCache . put_all ( %{ apples : 2 , oranges : 1 } , ttl : 10_000 ) :ok Ideally, this operation should be atomic, so all given keys are put at once. But it depends purely on the adapter's implementation and the backend used internally by the adapter. Hence, it is recommended to review the adapter's documentation.","ref":"Nebulex.Cache.html#c:put_all/2","title":"Nebulex.Cache.put_all/2","type":"callback"},{"doc":"Sets the dynamic cache to be used in further commands (based on Ecto dynamic repo). There might be cases where we want to have different cache instances but accessing them through the same cache module. By default, when you call MyApp.Cache.start_link/1 , it will start a cache with the name MyApp.Cache . But it is also possible to start multiple caches by using a different name for each of them: MyApp.Cache . start_link ( name : :cache1 ) MyApp.Cache . start_link ( name : :cache2 , backend : :shards ) You can also start caches without names by explicitly setting the name to nil : MyApp.Cache . start_link ( name : nil , backend : :shards ) NOTE: There may be adapters requiring the :name option anyway, therefore, it is highly recommended to see the adapter's documentation you want to use. However, once the cache is started, it is not possible to interact directly with it, since all operations through MyApp.Cache are sent by default to the cache named MyApp.Cache . But you can change the default cache at compile-time: use Nebulex.Cache , default_dynamic_cache : :cache_name Or anytime at runtime by calling put_dynamic_cache/1 : MyApp.Cache . put_dynamic_cache ( :another_cache_name ) From this moment on, all future commands performed by the current process will run on :another_cache_name .","ref":"Nebulex.Cache.html#c:put_dynamic_cache/1","title":"Nebulex.Cache.put_dynamic_cache/1","type":"callback"},{"doc":"Similar to put_new/3 but raises Nebulex.KeyAlreadyExistsError if the key already exists. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put_new! ( &quot;foo&quot; , &quot;bar&quot; ) true","ref":"Nebulex.Cache.html#c:put_new!/3","title":"Nebulex.Cache.put_new!/3","type":"callback"},{"doc":"Puts the given value under key into the cache, only if it does not already exist. Returns true if a value was set, otherwise, false is returned. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put_new ( &quot;foo&quot; , &quot;bar&quot; ) true iex&gt; MyCache . put_new ( &quot;foo&quot; , &quot;bar&quot; ) false If the value is nil, it is not stored (operation is skipped): iex&gt; MyCache . put_new ( &quot;other&quot; , nil ) true","ref":"Nebulex.Cache.html#c:put_new/3","title":"Nebulex.Cache.put_new/3","type":"callback"},{"doc":"Puts the given entries (key/value pairs) into the cache . It will not perform any operation at all even if just a single key already exists. Returns true if all entries were successfully set. It returns false if no key was set (at least one key already existed). Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . put_new_all ( apples : 3 , bananas : 1 ) true iex&gt; MyCache . put_new_all ( %{ apples : 3 , oranges : 1 } , ttl : 10_000 ) false Ideally, this operation should be atomic, so all given keys are put at once. But it depends purely on the adapter's implementation and the backend used internally by the adapter. Hence, it is recommended to review the adapter's documentation.","ref":"Nebulex.Cache.html#c:put_new_all/2","title":"Nebulex.Cache.put_new_all/2","type":"callback"},{"doc":"Similar to replace/3 but raises KeyError if key is not found. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . replace! ( &quot;foo&quot; , &quot;bar&quot; ) true","ref":"Nebulex.Cache.html#c:replace!/3","title":"Nebulex.Cache.replace!/3","type":"callback"},{"doc":"Alters the entry stored under key , but only if the entry already exists into the Cache. Returns true if a value was set, otherwise, false is returned. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Example iex&gt; MyCache . replace ( &quot;foo&quot; , &quot;bar&quot; ) false iex&gt; MyCache . put_new ( &quot;foo&quot; , &quot;bar&quot; ) true iex&gt; MyCache . replace ( &quot;foo&quot; , &quot;bar2&quot; ) true Update current value and TTL: iex&gt; MyCache . replace ( &quot;foo&quot; , &quot;bar3&quot; , ttl : 10_000 ) true","ref":"Nebulex.Cache.html#c:replace/3","title":"Nebulex.Cache.replace/3","type":"callback"},{"doc":"Returns the total number of cached entries. Examples iex&gt; :ok = Enum . each ( 1 .. 10 , &amp; MyCache . put ( &amp;1 , &amp;1 ) ) iex&gt; MyCache . size ( ) 10 iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . delete ( &amp;1 ) ) iex&gt; MyCache . size ( ) 5","ref":"Nebulex.Cache.html#c:size/0","title":"Nebulex.Cache.size/0","type":"callback"},{"doc":"Starts a supervision and return {:ok, pid} or just :ok if nothing needs to be done. Returns {:error, {:already_started, pid}} if the cache is already started or {:error, term} in case anything else goes wrong. Options See the configuration in the moduledoc for options shared between adapters, for adapter-specific configuration see the adapter's documentation.","ref":"Nebulex.Cache.html#c:start_link/1","title":"Nebulex.Cache.start_link/1","type":"callback"},{"doc":"Returns Nebulex.Stats.t() with the current stats values. If the stats are disabled for the cache, then nil is returned. Example iex&gt; MyCache . stats ( ) % Nebulex.Stats { measurements : { evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , updates : 0 , writes : 0 } , metadata : %{ } }","ref":"Nebulex.Cache.html#c:stats/0","title":"Nebulex.Cache.stats/0","type":"callback"},{"doc":"Shuts down the cache.","ref":"Nebulex.Cache.html#c:stop/1","title":"Nebulex.Cache.stop/1","type":"callback"},{"doc":"Similar to all/2 but returns a lazy enumerable that emits all entries from the cache matching the given query . If query is nil , then all entries in cache match and are returned when the stream is evaluated; based on the :return option. May raise Nebulex.QueryError if query validation fails. Query values See all/2 callback for more information about the query values. Options :return - Tells the query what to return from the matched entries. See the possible values in the &quot;Query return option&quot; section below. The default depends on the adapter, for example, the default for the built-in adapters is :key . This option is supported by the build-in adapters, but it is recommended to see the adapter's documentation to confirm its compatibility with this option. :page_size - Positive integer (&gt;= 1) that defines the page size internally used by the adapter for paginating the results coming back from the cache's backend. Defaults to 20 ; it's unlikely this will ever need changing. See the &quot;Shared options&quot; section at the module documentation for more options. Query return option The following are the possible values for the :return option: :key - Returns a list only with the keys. :value - Returns a list only with the values. :entry - Returns a list of Nebulex.Entry.t/0 . {:key, :value} - Returns a list of tuples in the form {key, value} . See adapters documentation to confirm what of these options are supported and what other added. Examples Populate the cache with some entries: iex&gt; :ok = Enum . each ( 1 .. 5 , &amp; MyCache . put ( &amp;1 , &amp;1 * 2 ) ) Stream all (with default params): iex&gt; MyCache . stream ( ) |&gt; Enum . to_list ( ) [ 1 , 2 , 3 , 4 , 5 ] Stream all entries and return values: iex&gt; nil |&gt; MyCache . stream ( return : :value , page_size : 3 ) |&gt; Enum . to_list ( ) [ 2 , 4 , 6 , 8 , 10 ] Stream all entries and return them as key/value pairs: iex&gt; nil |&gt; MyCache . stream ( return : { :key , :value } ) |&gt; Enum . to_list ( ) [ { 1 , 2 } , { 2 , 4 } , { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ] Additional built-in queries for Nebulex.Adapters.Local adapter: iex&gt; unexpired_stream = MyCache . stream ( :unexpired ) iex&gt; expired_stream = MyCache . stream ( :expired ) If we are using Nebulex.Adapters.Local adapter, the stored entry tuple {:entry, key, value, touched, ttl} , then the match spec could be something like: iex&gt; spec = [ ...&gt; { { :entry , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , ...&gt; [ { :&gt; , :&quot;$2&quot; , 5 } ] , [ { { :&quot;$1&quot; , :&quot;$2&quot; } } ] } ...&gt; ] iex&gt; MyCache . stream ( spec , page_size : 100 ) |&gt; Enum . to_list ( ) [ { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ] The same previous query but using Ex2ms : iex&gt; import Ex2ms Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { _ , key , value , _ , _ } when value &gt; 5 -&gt; { key , value } ...&gt; end iex&gt; spec |&gt; MyCache . stream ( page_size : 100 ) |&gt; Enum . to_list ( ) [ { 3 , 6 } , { 4 , 8 } , { 5 , 10 } ]","ref":"Nebulex.Cache.html#c:stream/2","title":"Nebulex.Cache.stream/2","type":"callback"},{"doc":"Similar to take/2 but raises KeyError if key is not found. Options See the &quot;Shared options&quot; section at the module documentation for more options. Example MyCache . take! ( :a )","ref":"Nebulex.Cache.html#c:take!/2","title":"Nebulex.Cache.take!/2","type":"callback"},{"doc":"Returns and removes the value associated with key in the Cache. If the key does not exist, then nil is returned. Options See the &quot;Shared options&quot; section at the module documentation for more options. Examples iex&gt; MyCache . put ( :a , 1 ) :ok iex&gt; MyCache . take ( :a ) 1 iex&gt; MyCache . take ( :a ) nil","ref":"Nebulex.Cache.html#c:take/2","title":"Nebulex.Cache.take/2","type":"callback"},{"doc":"Returns true if the given key exists and the last access time was successfully updated, otherwise, false is returned. Examples iex&gt; MyCache . put ( :a , 1 ) :ok iex&gt; MyCache . touch ( :a ) true iex&gt; MyCache . ttl ( :b ) false","ref":"Nebulex.Cache.html#c:touch/1","title":"Nebulex.Cache.touch/1","type":"callback"},{"doc":"Runs the given function inside a transaction. A successful transaction returns the value returned by the function. Options See the &quot;Shared options&quot; section at the module documentation for more options. Examples MyCache . transaction fn -&gt; alice = MyCache . get ( :alice ) bob = MyCache . get ( :bob ) MyCache . put ( :alice , %{ alice | balance : alice . balance + 100 } ) MyCache . put ( :bob , %{ bob | balance : bob . balance + 100 } ) end Locking only the involved key (recommended): MyCache . transaction [ keys : [ :alice , :bob ] ] , fn -&gt; alice = MyCache . get ( :alice ) bob = MyCache . get ( :bob ) MyCache . put ( :alice , %{ alice | balance : alice . balance + 100 } ) MyCache . put ( :bob , %{ bob | balance : bob . balance + 100 } ) end","ref":"Nebulex.Cache.html#c:transaction/2","title":"Nebulex.Cache.transaction/2","type":"callback"},{"doc":"Returns the remaining time-to-live for the given key . If the key does not exist, then nil is returned. Examples iex&gt; MyCache . put ( :a , 1 , ttl : 5000 ) :ok iex&gt; MyCache . put ( :b , 2 ) :ok iex&gt; MyCache . ttl ( :a ) _remaining_ttl iex&gt; MyCache . ttl ( :b ) :infinity iex&gt; MyCache . ttl ( :c ) nil","ref":"Nebulex.Cache.html#c:ttl/1","title":"Nebulex.Cache.ttl/1","type":"callback"},{"doc":"Updates the cached key with the given function. If key is present in Cache with value value , fun is invoked with argument value and its result is used as the new value of key . If key is not present in Cache, initial is inserted as the value of key . The initial value will not be passed through the update function. Options :ttl - (positive integer or :infinity ) Defines the time-to-live (or expiry time) for the given key in milliseconds . Defaults to :infinity . See the &quot;Shared options&quot; section at the module documentation for more options. Examples iex&gt; MyCache . update ( :a , 1 , &amp; ( &amp;1 * 2 ) ) 1 iex&gt; MyCache . update ( :a , 1 , &amp; ( &amp;1 * 2 ) ) 2","ref":"Nebulex.Cache.html#c:update/4","title":"Nebulex.Cache.update/4","type":"callback"},{"doc":"Invokes the given function fun for the dynamic cache name_or_pid . Example MyCache . with_dynamic_cache ( :my_cache , fn -&gt; MyCache . put ( &quot;foo&quot; , &quot;var&quot; ) end ) See get_dynamic_cache/0 and put_dynamic_cache/1 .","ref":"Nebulex.Cache.html#c:with_dynamic_cache/2","title":"Nebulex.Cache.with_dynamic_cache/2","type":"callback"},{"doc":"For the dynamic cache name_or_pid , invokes the given function name fun from module with the list of arguments args . Example MyCache . with_dynamic_cache ( :my_cache , Module , :some_fun , [ &quot;foo&quot; , &quot;bar&quot; ] ) See get_dynamic_cache/0 and put_dynamic_cache/1 .","ref":"Nebulex.Cache.html#c:with_dynamic_cache/4","title":"Nebulex.Cache.with_dynamic_cache/4","type":"callback"},{"doc":"Cache entries","ref":"Nebulex.Cache.html#t:entries/0","title":"Nebulex.Cache.entries/0","type":"type"},{"doc":"Cache entry key","ref":"Nebulex.Cache.html#t:key/0","title":"Nebulex.Cache.key/0","type":"type"},{"doc":"Cache action options","ref":"Nebulex.Cache.html#t:opts/0","title":"Nebulex.Cache.opts/0","type":"type"},{"doc":"","ref":"Nebulex.Cache.html#t:t/0","title":"Nebulex.Cache.t/0","type":"type"},{"doc":"Cache entry value","ref":"Nebulex.Cache.html#t:value/0","title":"Nebulex.Cache.value/0","type":"type"},{"doc":"Declarative annotation-based caching via function decorators . For caching declaration, the abstraction provides three Elixir function decorators: cacheable , cache_evict , and cache_put , which allow functions to trigger cache population or cache eviction. Let us take a closer look at each annotation. Inspired by Spring Cache Abstraction . cacheable decorator As the name implies, cacheable is used to demarcate functions that are cacheable - that is, functions for whom the result is stored into the cache so, on subsequent invocations (with the same arguments), the value in the cache is returned without having to actually execute the function. In its simplest form, the decorator/annotation declaration requires the name of the cache associated with the annotated function: @decorate cacheable ( cache : Cache ) def get_account ( id ) do # the logic for retrieving the account ... end In the snippet above, the function get_account/1 is associated with the cache named Cache . Each time the function is called, the cache is checked to see whether the invocation has been already executed and does not have to be repeated. Default Key Generation Since caches are essentially key-value stores, each invocation of a cached function needs to be translated into a suitable key for cache access. Out of the box, the caching abstraction uses a simple key-generator based on the following algorithm: If no params are given, return 0 . If only one param is given, return that param as key. If more than one param is given, return a key computed from the hashes of all parameters ( :erlang.phash2(args) ). IMPORTANT: Since Nebulex v2.1.0, the default key generation implements the algorithm described above, breaking backward compatibility with older versions. Therefore, you may need to change your code in case of using the default key generation. The default key generator is provided by the cache via the callback Nebulex.Cache.__default_key_generator__/0 and it is applied only if the option key: or keys: is not configured. By default it is Nebulex.Caching.SimpleKeyGenerator . But you can change the default key generator at compile time with the option :default_key_generator . For example, one can define a cache with a default key generator as: defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local , default_key_generator : __MODULE__ @behaviour Nebulex.Caching.KeyGenerator @impl true def generate ( mod , fun , args ) , do : :erlang . phash2 ( { mod , fun , args } ) end The key generator module must implement the Nebulex.Caching.KeyGenerator behaviour. IMPORTANT: There are some caveats to keep in mind when using the key generator, therefore, it is highly recommended to review Nebulex.Caching.KeyGenerator behaviour documentation before. Also, you can provide a different key generator at any time (overriding the default one) when using any caching annotation through the option :key_generator . For example: # With a module implementing the key-generator behaviour @decorate cache_put ( cache : Cache , key_generator : CustomKeyGenerator ) def update_account ( account ) do # the logic for updating the given entity ... end # With the shorthand tuple {module, args} @decorate cache_put ( cache : Cache , key_generator : { CustomKeyGenerator , [ account . name ] } ) def update_account2 ( account ) do # the logic for updating the given entity ... end # With a MFA tuple @decorate cache_put ( cache : Cache , key_generator : { AnotherModule , :genkey , [ account . id ] } ) def update_account3 ( account ) do # the logic for updating the given entity ... end The :key_generator option is available for all caching annotations. Custom Key Generation Declaration Since caching is generic, it is quite likely the target functions have various signatures that cannot be simply mapped on top of the cache structure. This tends to become obvious when the target function has multiple arguments out of which only some are suitable for caching (while the rest are used only by the function logic). For example: @decorate cacheable ( cache : Cache ) def get_account ( email , include_users? ) do # the logic for retrieving the account ... end At first glance, while the boolean argument influences the way the account is found, it is no use for the cache. For such cases, the cacheable decorator allows the user to specify the key explicitly based on the function attributes. @decorate cacheable ( cache : Cache , key : { Account , email } ) def get_account ( email , include_users? ) do # the logic for retrieving the account ... end @decorate cacheable ( cache : Cache , key : { Account , user . account_id } ) def get_user_account ( % User { } = user ) do # the logic for retrieving the account ... end It is also possible passing options to the cache, like so: @decorate cacheable ( cache : Cache , key : { Account , email } , opts : [ ttl : 300_000 ] ) def get_account ( email , include_users? ) do # the logic for retrieving the account ... end See the &quot;Shared Options&quot; section below. Functions with multiple clauses Since decorator lib is used, it is important to be aware of its recommendations, warns, limitations, and so on. In this case, for functions with multiple clauses the general advice is to create an empty function head, and call the decorator on that head, like so: @decorate cacheable ( cache : Cache , key : email ) def get_account ( email \\\\ nil ) def get_account ( nil ) , do : nil def get_account ( email ) do # the logic for retrieving the account ... end cache_put decorator For cases where the cache needs to be updated without interfering with the function execution, one can use the cache_put decorator. That is, the method will always be executed and its result placed into the cache (according to the cache_put options). It supports the same options as cacheable . @decorate cache_put ( cache : Cache , key : { Account , acct . email } ) def update_account ( % Account { } = acct , attrs ) do # the logic for updating the account ... end Note that using cache_put and cacheable annotations on the same function is generally discouraged because they have different behaviors. While the latter causes the method execution to be skipped by using the cache, the former forces the execution in order to execute a cache update. This leads to unexpected behavior and with the exception of specific corner-cases (such as decorators having conditions that exclude them from each other), such declarations should be avoided. cache_evict decorator The cache abstraction allows not just the population of a cache store but also eviction. This process is useful for removing stale or unused data from the cache. Opposed to cacheable , the decorator cache_evict demarcates functions that perform cache eviction, which are functions that act as triggers for removing data from the cache. The cache_evict decorator not only allows a key to be specified, but also a set of keys. Besides, extra options like all_entries which indicates whether a cache-wide eviction needs to be performed rather than just an entry one (based on the key or keys): @decorate cache_evict ( cache : Cache , key : { Account , email } ) def delete_account_by_email ( email ) do # the logic for deleting the account ... end @decorate cacheable ( cache : Cache , keys : [ { Account , acct . id } , { Account , acct . email } ] ) def delete_account ( % Account { } = acct ) do # the logic for deleting the account ... end @decorate cacheable ( cache : Cache , all_entries : true ) def delete_all_accounts do # the logic for deleting all the accounts ... end The option all_entries: comes in handy when an entire cache region needs to be cleared out - rather than evicting each entry (which would take a long time since it is inefficient), all the entries are removed in one operation as shown above. Shared Options All three cache annotations explained previously accept the following options: :cache - Defines what cache to use (required). Raises ArgumentError if the option is not present. :key - Defines the cache access key (optional). It overrides the :key_generator option. If this option is not present, a default key is generated by the configured or default key generator. :opts - Defines the cache options that will be passed as argument to the invoked cache function (optional). :match - Match function (term -&gt; boolean | {true, term}) (optional). This function is for matching and decide whether the code-block evaluation result is cached or not. If true the code-block evaluation result is cached as it is (the default). If {true, value} is returned, then the value is what is cached (useful to control what is meant to be cached). Returning false will cause that nothing is stored in the cache. :key_generator - The custom key-generator to be used (optional). If present, this option overrides the default key generator provided by the cache, and it is applied only if the option key: or keys: is not present. In other words, the option key: or keys: overrides the :key_generator option. See &quot;The :key_generator option&quot; section below for more information about the possible values. :on_error - It may be one of :raise (the default) or :nothing . The decorators/annotations call the cache under the hood, hence, by default, any error or exception at executing a cache command is propagated. When this option is set to :nothing , any error or exception executing a cache command is ignored and the annotated function is executed normally. The :key_generator option The possible values for the :key_generator are: A module implementing the Nebulex.Caching.KeyGenerator behaviour. A MFA tuple {module, function, args} for a function to call to generate the key before the cache is invoked. A shorthand value of {module, args} is equivalent to {module, :generate, [calling_module, calling_function_name, args]} . Putting all together Supposing we are using Ecto and we want to define some cacheable functions within the context MyApp.Accounts : # The config config :my_app , MyApp.Cache , gc_interval : 86_400_000 , #=&gt; 1 day backend : :shards # The Cache defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end # Some Ecto schema defmodule MyApp.Accounts.User do use Ecto.Schema schema &quot;users&quot; do field ( :username , :string ) field ( :password , :string ) field ( :role , :string ) end def changeset ( user , attrs ) do user |&gt; cast ( attrs , [ :username , :password , :role ] ) |&gt; validate_required ( [ :username , :password , :role ] ) end end # Accounts context defmodule MyApp.Accounts do use Nebulex.Caching alias MyApp.Accounts.User alias MyApp . { Cache , Repo } @ttl :timer . hours ( 1 ) @decorate cacheable ( cache : Cache , key : { User , id } , opts : [ ttl : @ttl ] ) def get_user! ( id ) do Repo . get! ( User , id ) end @decorate cacheable ( cache : Cache , key : { User , username } , opts : [ ttl : @ttl ] ) def get_user_by_username ( username ) do Repo . get_by ( User , [ username : username ] ) end @decorate cache_put ( cache : Cache , keys : [ { User , usr . id } , { User , usr . username } ] , match : &amp; match_update / 1 ) def update_user ( % User { } = usr , attrs ) do usr |&gt; User . changeset ( attrs ) |&gt; Repo . update ( ) end defp match_update ( { :ok , usr } ) , do : { true , usr } defp match_update ( { :error , _ } ) , do : false @decorate cache_evict ( cache : Cache , keys : [ { User , usr . id } , { User , usr . username } ] ) def delete_user ( % User { } = usr ) do Repo . delete ( usr ) end def create_user ( attrs \\\\ %{ } ) do % User { } |&gt; User . changeset ( attrs ) |&gt; Repo . insert ( ) end end See Cache Usage Patters Guide .","ref":"Nebulex.Caching.html","title":"Nebulex.Caching","type":"module"},{"doc":"","ref":"Nebulex.Caching.html#cache_evict/1","title":"Nebulex.Caching.cache_evict/1","type":"macro"},{"doc":"Provides a way of annotating functions to be evicted (eviction aspect). On function's completion, the given key or keys (depends on the :key and :keys options) are deleted from the cache. Options :keys - Defines the set of keys to be evicted from cache on function completion. It overrides :key and :key_generator options. :all_entries - Defines if all entries must be removed on function completion. Defaults to false . :before_invocation - Boolean to indicate whether the eviction should occur after (the default) or before the function executes. The former provides the same semantics as the rest of the annotations; once the function completes successfully, an action (in this case eviction) on the cache is executed. If the function does not execute (as it might be cached) or an exception is raised, the eviction does not occur. The latter ( before_invocation: true ) causes the eviction to occur always, before the function is invoked; this is useful in cases where the eviction does not need to be tied to the function outcome. See the &quot;Shared options&quot; section at the module documentation. Examples defmodule MyApp.Example do use Nebulex.Caching alias MyApp.Cache @decorate cache_evict ( cache : Cache , key : id ) def delete ( id ) do # your logic (maybe write/delete data to the SoR) end @decorate cache_evict ( cache : Cache , keys : [ object . name , object . id ] ) def delete_object ( object ) do # your logic (maybe write/delete data to the SoR) end @decorate cache_evict ( cache : Cache , all_entries : true ) def delete_all do # your logic (maybe write/delete data to the SoR) end end The Write-through pattern is supported by this decorator. Your function provides the logic to write data to the system-of-record (SoR) and the rest is provided by the decorator under-the-hood. But in contrast with update decorator, when the data is written to the SoR, the key for that value is deleted from cache instead of updated.","ref":"Nebulex.Caching.html#cache_evict/3","title":"Nebulex.Caching.cache_evict/3","type":"function"},{"doc":"","ref":"Nebulex.Caching.html#cache_put/1","title":"Nebulex.Caching.cache_put/1","type":"macro"},{"doc":"Provides a way of annotating functions to be evicted; but updating the cached key instead of deleting it. The content of the cache is updated without interfering with the function execution. That is, the method would always be executed and the result cached. The difference between cacheable/3 and cache_put/3 is that cacheable/3 will skip running the function if the key exists in the cache, whereas cache_put/3 will actually run the function and then put the result in the cache. Options :keys - The set of cached keys to be updated with the returned value on function completion. It overrides :key and :key_generator options. See the &quot;Shared options&quot; section at the module documentation. Examples defmodule MyApp.Example do use Nebulex.Caching alias MyApp.Cache @ttl :timer . hours ( 1 ) @decorate cache_put ( cache : Cache , key : id , opts : [ ttl : @ttl ] ) def update! ( id , attrs \\\\ %{ } ) do # your logic (maybe write data to the SoR) end @decorate cache_put ( cache : Cache , key : id , match : &amp; match_fun / 1 , opts : [ ttl : @ttl ] ) def update ( id , attrs \\\\ %{ } ) do # your logic (maybe write data to the SoR) end @decorate cache_put ( cache : Cache , keys : [ object . name , object . id ] , match : &amp; match_fun / 1 , opts : [ ttl : @ttl ] ) def update_object ( object ) do # your logic (maybe write data to the SoR) end defp match_fun ( { :ok , updated } ) , do : { true , updated } defp match_fun ( { :error , _ } ) , do : false end The Write-through pattern is supported by this decorator. Your function provides the logic to write data to the system-of-record (SoR) and the rest is provided by the decorator under-the-hood.","ref":"Nebulex.Caching.html#cache_put/3","title":"Nebulex.Caching.cache_put/3","type":"function"},{"doc":"Convenience function for cache_put annotation. NOTE: Internal purposes only.","ref":"Nebulex.Caching.html#cache_put/4","title":"Nebulex.Caching.cache_put/4","type":"function"},{"doc":"","ref":"Nebulex.Caching.html#cacheable/1","title":"Nebulex.Caching.cacheable/1","type":"macro"},{"doc":"Provides a way of annotating functions to be cached (cacheable aspect). The returned value by the code block is cached if it doesn't exist already in cache, otherwise, it is returned directly from cache and the code block is not executed. Options See the &quot;Shared options&quot; section at the module documentation. Examples defmodule MyApp.Example do use Nebulex.Caching alias MyApp.Cache @ttl :timer . hours ( 1 ) @decorate cacheable ( cache : Cache , key : name ) def get_by_name ( name , age ) do # your logic (maybe the loader to retrieve the value from the SoR) end @decorate cacheable ( cache : Cache , key : age , opts : [ ttl : @ttl ] ) def get_by_age ( age ) do # your logic (maybe the loader to retrieve the value from the SoR) end @decorate cacheable ( cache : Cache , key : clauses , match : &amp; match_fun / 1 ) def all ( clauses ) do # your logic (maybe the loader to retrieve the value from the SoR) end defp match_fun ( [ ] ) , do : false defp match_fun ( _ ) , do : true end The Read-through pattern is supported by this decorator. The loader to retrieve the value from the system-of-record (SoR) is your function's logic and the rest is provided by the macro under-the-hood.","ref":"Nebulex.Caching.html#cacheable/3","title":"Nebulex.Caching.cacheable/3","type":"function"},{"doc":"This function is for internal purposes only. NOTE: Workaround to avoid dialyzer warnings when using declarative annotation-based caching via decorators.","ref":"Nebulex.Caching.html#eval_match/5","title":"Nebulex.Caching.eval_match/5","type":"function"},{"doc":"Convenience function for ignoring cache errors when :on_error option is set to :nothing NOTE: Internal purposes only.","ref":"Nebulex.Caching.html#run_cmd/5","title":"Nebulex.Caching.run_cmd/5","type":"function"},{"doc":"Cache key generator. Used for creating a key based on the given module, function name and its arguments (the module and function name are used as context). See the default implementation Nebulex.Caching.SimpleKeyGenerator . Caveats when using the key generator Since the callback generate/3 is invoked passing the calling module where the annotated function is defined, the name of the annotated function, and the arguments given to that annotated function, there are some caveats to keep in mind: Only arguments explicitly assigned to a variable will be included when calling the callback generate/3 . Ignored or underscored arguments will be ignored. Pattern-matching expressions without a variable assignment will be ignored. If there is a pattern-matching, it has to be explicitly assigned to a variable so it can be included when calling the callback generate/3 . For example, suppose you have a module with an annotated function: defmodule MyApp.SomeModule do use Nebulex.Caching alias MyApp . { Cache , CustomKeyGenerator } @decorate cacheable ( cache : Cache , key_generator : CustomKeyGenerator ) def get_something ( x , _ignored , _ , { _ , _ } , [ _ , _ ] , %{ a : a } , %{ } = y ) do # Function&#39;s logic end end The generator will be invoked like so: MyKeyGenerator . generate ( MyApp.SomeModule , :get_something , [ x , y ] ) Based on the caveats described above, only the arguments x and y are included when calling the callback generate/3 .","ref":"Nebulex.Caching.KeyGenerator.html","title":"Nebulex.Caching.KeyGenerator","type":"behaviour"},{"doc":"Generates a key for the given module , function_name , and its args .","ref":"Nebulex.Caching.KeyGenerator.html#c:generate/3","title":"Nebulex.Caching.KeyGenerator.generate/3","type":"callback"},{"doc":"Key generator type","ref":"Nebulex.Caching.KeyGenerator.html#t:t/0","title":"Nebulex.Caching.KeyGenerator.t/0","type":"type"},{"doc":"Default key generator implementation. It implementats a simple algorithm: If no params are given, return 0 . If only one param is given, return that param as key. If more than one param is given, return a key computed from the hashes of all parameters ( :erlang.phash2(args) ). Based on the default key generation in Spring Cache Abstraction . This implementation aims to cover those simple/generic scenarios where the key generated based on the arguments only, fulfill the needs. For example: defmodule MyApp.Users do use Nebulex.Caching alias MayApp.Cache @decorate cacheable ( cache : Cache ) def get_user ( id ) do # logic for retrieving a user... end @decorate cache_evict ( cache : Cache ) def delete_user ( id ) do # logic for deleting a user... end end The key generator will generate the same key for both, cacheable and evict functions; since it is generated based on the arguments only.","ref":"Nebulex.Caching.SimpleKeyGenerator.html","title":"Nebulex.Caching.SimpleKeyGenerator","type":"module"},{"doc":"Defines a Cache Entry. This is the structure used by the caches for representing cache entries.","ref":"Nebulex.Entry.html","title":"Nebulex.Entry","type":"module"},{"doc":"Decodes a previously encoded entry. Example iex&gt; &quot;hello&quot; ...&gt; |&gt; Nebulex.Entry . encode ( ) ...&gt; |&gt; Nebulex.Entry . decode ( ) &quot;hello&quot;","ref":"Nebulex.Entry.html#decode/2","title":"Nebulex.Entry.decode/2","type":"function"},{"doc":"Encodes a cache entry. Example iex&gt; &quot;hello&quot; ...&gt; |&gt; Nebulex.Entry . encode ( ) ...&gt; |&gt; Nebulex.Entry . decode ( ) &quot;hello&quot;","ref":"Nebulex.Entry.html#encode/2","title":"Nebulex.Entry.encode/2","type":"function"},{"doc":"Returns whether the given entry has expired or not. Example iex&gt; Nebulex.Entry . expired? ( % Nebulex.Entry { } ) false iex&gt; Nebulex.Entry . expired? ( ...&gt; % Nebulex.Entry { touched : Nebulex.Time . now ( ) - 10 , ttl : 1 } ...&gt; ) true","ref":"Nebulex.Entry.html#expired?/1","title":"Nebulex.Entry.expired?/1","type":"function"},{"doc":"Returns the remaining time-to-live. Example iex&gt; Nebulex.Entry . ttl ( % Nebulex.Entry { } ) :infinity iex&gt; ttl = ...&gt; Nebulex.Entry . ttl ( ...&gt; % Nebulex.Entry { touched : Nebulex.Time . now ( ) , ttl : 100 } ...&gt; ) iex&gt; ttl &gt; 0 true","ref":"Nebulex.Entry.html#ttl/1","title":"Nebulex.Entry.ttl/1","type":"function"},{"doc":"Defines a generic struct for a cache entry. The entry depends on the adapter completely, this struct/type aims to define the common fields.","ref":"Nebulex.Entry.html#t:t/0","title":"Nebulex.Entry.t/0","type":"type"},{"doc":"Pre/Post Hooks Since v2.0.0 , pre/post hooks are not supported and/or handled by Nebulex itself. Hooks feature is not a common use-case and also it is something that can be be easily implemented on top of the Cache at the application level. Nevertheless, to keep backward compatibility somehow, Nebulex provides the next decorators for implementing pre/post hooks very easily. before decorator The before decorator is declared for performing a hook action or callback before the annotated function is executed. @decorate before ( fn % Nebulex.Hook { } = hook -&gt; inspect ( hook ) end ) def some_fun ( var ) do # logic ... end after_return decorator The after_return decorator is declared for performing a hook action or callback after the annotated function is executed and its return is passed through the return: attribute. @decorate after_return ( &amp; inspect ( &amp;1 . return ) ) def some_fun ( var ) do # logic ... end around decorator The final kind of hook is around decorator. The around decorator runs &quot;around&quot; the annotated function execution. It has the opportunity to do work both before and after the function executes. This means the given hook function is invoked twice, before and after the code-block is evaluated. @decorate around ( &amp; inspect ( &amp;1 . step ) ) def some_fun ( var ) do # logic ... end Putting all together Suppose we want to track all cache calls (before and after they are called) by logging them (including the execution time). In this case, we need to provide a pre/post hook to log these calls. First of all, we have to create a module implementing the hook function: defmodule MyApp.Tracker do use GenServer alias Nebulex.Hook require Logger @actions [ :get , :put ] ## API def start_link ( opts \\\\ [ ] ) do GenServer . start_link ( __MODULE__ , opts , name : __MODULE__ ) end def track ( % Hook { step : :before , name : name } ) when name in @actions do System . system_time ( :microsecond ) end def track ( % Hook { step : :after_return , name : name } = event ) when name in @actions do GenServer . cast ( __MODULE__ , { :track , event } ) end def track ( hook ) , do : hook ## GenServer Callbacks @impl true def init ( _opts ) do { :ok , %{ } } end @impl true def handle_cast ( { :track , % Hook { acc : start } = hook } , state ) do diff = System . system_time ( :microsecond ) - start Logger . info ( &quot;#=&gt; \#{ hook . module } . \#{ hook . name } / \#{ hook . arity } , Duration: \#{ diff } &quot; ) { :noreply , state } end end And then, in the Cache: defmodule MyApp.Cache do use Nebulex.Hook @decorate_all around ( &amp; MyApp.Tracker . track / 1 ) use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end Try it out: iex&gt; MyApp.Cache . put 1 , 1 10 : 19 : 47.736 [ info ] Elixir.MyApp.Cache . put / 3 , Duration : 27 iex&gt; MyApp.Cache . get 1 10 : 20 : 14.941 [ info ] Elixir.MyApp.Cache . get / 2 , Duration : 11","ref":"Nebulex.Hook.html","title":"Nebulex.Hook","type":"module"},{"doc":"","ref":"Nebulex.Hook.html#after_return/1","title":"Nebulex.Hook.after_return/1","type":"macro"},{"doc":"After-return decorator. Intercepts any call to the annotated function and calls the given fun after the logic is executed, and the returned result is passed through the return: attribute. Example defmodule MyApp.Example do use Nebulex.Hook @decorate after_return ( &amp; inspect ( &amp;1 ) ) def some_fun ( var ) do # logic ... end end","ref":"Nebulex.Hook.html#after_return/3","title":"Nebulex.Hook.after_return/3","type":"function"},{"doc":"","ref":"Nebulex.Hook.html#around/1","title":"Nebulex.Hook.around/1","type":"macro"},{"doc":"Around decorator. Intercepts any call to the annotated function and calls the given fun before and after the logic is executed. The result of the first call to the hook function is passed through the acc: attribute, so it can be used in the next call (after return). Finally, as the after_return decorator, the returned code-block evaluation is passed through the return: attribute. Example defmodule MyApp.Profiling do alias Nebulex.Hook def prof ( % Hook { step : :before } ) do System . system_time ( :microsecond ) end def prof ( % Hook { step : :after_return , acc : start } = hook ) do :telemetry . execute ( [ :my_app , :profiling ] , %{ duration : System . system_time ( :microsecond ) - start } , %{ module : hook . module , name : hook . name } ) end end defmodule MyApp.Example do use Nebulex.Hook @decorate around ( &amp; MyApp.Profiling . prof / 1 ) def some_fun ( var ) do # logic ... end end","ref":"Nebulex.Hook.html#around/3","title":"Nebulex.Hook.around/3","type":"function"},{"doc":"","ref":"Nebulex.Hook.html#before/1","title":"Nebulex.Hook.before/1","type":"macro"},{"doc":"Before decorator. Intercepts any call to the annotated function and calls the given fun before the logic is executed. Example defmodule MyApp.Example do use Nebulex.Hook @decorate before ( &amp; inspect ( &amp;1 ) ) def some_fun ( var ) do # logic ... end end","ref":"Nebulex.Hook.html#before/3","title":"Nebulex.Hook.before/3","type":"function"},{"doc":"This function is for internal purposes.","ref":"Nebulex.Hook.html#eval_hook/3","title":"Nebulex.Hook.eval_hook/3","type":"function"},{"doc":"","ref":"Nebulex.Hook.html#t:hook_fun/0","title":"Nebulex.Hook.hook_fun/0","type":"type"},{"doc":"","ref":"Nebulex.Hook.html#t:t/0","title":"Nebulex.Hook.t/0","type":"type"},{"doc":"RPC utilities for distributed task execution. This module uses supervised tasks underneath Task.Supervisor . NOTE: The approach by using distributed tasks will be deprecated in the future in favor of :erpc .","ref":"Nebulex.RPC.html","title":"Nebulex.RPC","type":"module"},{"doc":"Evaluates apply(mod, fun, args) on node node and returns the corresponding evaluation result, or {:badrpc, reason} if the call fails. A timeout, in milliseconds or :infinity , can be given with a default value of 5000 . It uses Task.await/2 internally. Example iex&gt; Nebulex.RPC . call ( :my_task_sup , :node1 , Kernel , :to_string , [ 1 ] ) &quot;1&quot;","ref":"Nebulex.RPC.html#call/6","title":"Nebulex.RPC.call/6","type":"function"},{"doc":"In contrast to a regular single-node RPC, a multicall is an RPC that is sent concurrently from one client to multiple servers. The function evaluates apply(mod, fun, args) on each node_group entry and collects the answers. Then, evaluates the reducer function (set in the opts ) on each answer. This function is similar to :rpc.multicall/5 . Options :timeout - A timeout, in milliseconds or :infinity , can be given with a default value of 5000 . It uses Task.yield_many/2 internally. :reducer - Reducer function to be executed on each collected result. (check out reducer type). Example iex&gt; Nebulex.RPC . multi_call ( ...&gt; :my_task_sup , ...&gt; %{ ...&gt; node1 : { Kernel , :to_string , [ 1 ] } , ...&gt; node2 : { Kernel , :to_string , [ 2 ] } ...&gt; } , ...&gt; timeout : 10_000 , ...&gt; reducer : { ...&gt; [ ] , ...&gt; fn ...&gt; { :ok , res } , _node_callback , acc -&gt; ...&gt; [ res | acc ] ...&gt; ...&gt; { :error , _ } , _node_callback , acc -&gt; ...&gt; acc ...&gt; end ...&gt; } ...&gt; ) [ &quot;1&quot; , &quot;2&quot; ]","ref":"Nebulex.RPC.html#multi_call/3","title":"Nebulex.RPC.multi_call/3","type":"function"},{"doc":"Similar to multi_call/3 but the same node_callback (given by module , fun , args ) is executed on all nodes ; Internally it creates a node_group with the same node_callback for each node. Options Same options as multi_call/3 . Example iex&gt; Nebulex.RPC . multi_call ( ...&gt; :my_task_sup , ...&gt; [ :node1 , :node2 ] , ...&gt; Kernel , ...&gt; :to_string , ...&gt; [ 1 ] , ...&gt; timeout : 5000 , ...&gt; reducer : { ...&gt; [ ] , ...&gt; fn ...&gt; { :ok , res } , _node_callback , acc -&gt; ...&gt; [ res | acc ] ...&gt; ...&gt; { :error , _ } , _node_callback , acc -&gt; ...&gt; acc ...&gt; end ...&gt; } ...&gt; ) [ &quot;1&quot; , &quot;1&quot; ]","ref":"Nebulex.RPC.html#multi_call/6","title":"Nebulex.RPC.multi_call/6","type":"function"},{"doc":"","ref":"Nebulex.RPC.html#rpc_multi_call/3","title":"Nebulex.RPC.rpc_multi_call/3","type":"function"},{"doc":"","ref":"Nebulex.RPC.html#rpc_multi_call/6","title":"Nebulex.RPC.rpc_multi_call/6","type":"function"},{"doc":"Task callback","ref":"Nebulex.RPC.html#t:callback/0","title":"Nebulex.RPC.callback/0","type":"type"},{"doc":"Group entry: node -&gt; callback","ref":"Nebulex.RPC.html#t:node_callback/0","title":"Nebulex.RPC.node_callback/0","type":"type"},{"doc":"Node group","ref":"Nebulex.RPC.html#t:node_group/0","title":"Nebulex.RPC.node_group/0","type":"type"},{"doc":"Reducer spec","ref":"Nebulex.RPC.html#t:reducer/0","title":"Nebulex.RPC.reducer/0","type":"type"},{"doc":"Reducer function spec","ref":"Nebulex.RPC.html#t:reducer_fun/0","title":"Nebulex.RPC.reducer_fun/0","type":"type"},{"doc":"Task supervisor","ref":"Nebulex.RPC.html#t:task_sup/0","title":"Nebulex.RPC.task_sup/0","type":"type"},{"doc":"Stats data type. Stats struct defines two main keys: :measurements - A map with the measurements provided by the underlying adapter. :metadata - A map for including additional information; also provided by the underlying adapter. Measurements The following measurements are expected to be present and fed by the underlying adapter: :evictions - When a cache entry is removed. :expirations - When a cache entry is expired. :hits - When a key is looked up in cache and found. :misses - When a key is looked up in cache but not found. :updates - When an existing cache entry is or updated. :writes - When a cache entry is inserted or overwritten. Metadata Despite the adapters can include any additional or custom metadata, It is recommended they include the following keys: :cache - The cache module, or the name (if an explicit name has been given to the cache). IMPORTANT: Since the adapter may include any additional or custom measurements, as well as metadata, it is recommended to check out the adapter's documentation.","ref":"Nebulex.Stats.html","title":"Nebulex.Stats","type":"module"},{"doc":"Nebulex.Stats data type","ref":"Nebulex.Stats.html#t:t/0","title":"Nebulex.Stats.t/0","type":"type"},{"doc":"Telemetry wrapper.","ref":"Nebulex.Telemetry.html","title":"Nebulex.Telemetry","type":"module"},{"doc":"See :telemetry.attach_many/4 .","ref":"Nebulex.Telemetry.html#attach_many/4","title":"Nebulex.Telemetry.attach_many/4","type":"function"},{"doc":"See :telemetry.detach/1 .","ref":"Nebulex.Telemetry.html#detach/1","title":"Nebulex.Telemetry.detach/1","type":"function"},{"doc":"See :telemetry.execute/3 .","ref":"Nebulex.Telemetry.html#execute/3","title":"Nebulex.Telemetry.execute/3","type":"function"},{"doc":"See :telemetry.span/3 .","ref":"Nebulex.Telemetry.html#span/3","title":"Nebulex.Telemetry.span/3","type":"function"},{"doc":"Telemetry handler for aggregating cache stats; it relies on the default stats implementation based on Erlang counters. See Nebulex.Adapter.Stats . This handler is used by the built-in local adapter when the option :stats is set to true .","ref":"Nebulex.Telemetry.StatsHandler.html","title":"Nebulex.Telemetry.StatsHandler","type":"module"},{"doc":"Time utilities.","ref":"Nebulex.Time.html","title":"Nebulex.Time","type":"module"},{"doc":"Returns the current system time in the given time unit. The unit is set to :millisecond by default. Examples iex&gt; now = Nebulex.Time . now ( ) iex&gt; is_integer ( now ) and now &gt; 0 true","ref":"Nebulex.Time.html#now/1","title":"Nebulex.Time.now/1","type":"function"},{"doc":"Returns true if the given timeout is a valid timeout; otherwise, false is returned. Valid timeout: :infinity | non_neg_integer() . Examples iex&gt; Nebulex.Time . timeout? ( 1 ) true iex&gt; Nebulex.Time . timeout? ( :infinity ) true iex&gt; Nebulex.Time . timeout? ( - 1 ) false iex&gt; Nebulex.Time . timeout? ( 1.1 ) false","ref":"Nebulex.Time.html#timeout?/1","title":"Nebulex.Time.timeout?/1","type":"function"},{"doc":"Raised at runtime when a key already exists in cache.","ref":"Nebulex.KeyAlreadyExistsError.html","title":"Nebulex.KeyAlreadyExistsError","type":"exception"},{"doc":"","ref":"Nebulex.KeyAlreadyExistsError.html#t:t/0","title":"Nebulex.KeyAlreadyExistsError.t/0","type":"type"},{"doc":"Raised at runtime when the query is invalid.","ref":"Nebulex.QueryError.html","title":"Nebulex.QueryError","type":"exception"},{"doc":"","ref":"Nebulex.QueryError.html#t:t/0","title":"Nebulex.QueryError.t/0","type":"type"},{"doc":"Raised at runtime when a RPC error occurs.","ref":"Nebulex.RPCError.html","title":"Nebulex.RPCError","type":"exception"},{"doc":"","ref":"Nebulex.RPCError.html#t:t/0","title":"Nebulex.RPCError.t/0","type":"type"},{"doc":"Raised at runtime when a RPC multi_call error occurs.","ref":"Nebulex.RPCMultiCallError.html","title":"Nebulex.RPCMultiCallError","type":"exception"},{"doc":"","ref":"Nebulex.RPCMultiCallError.html#t:t/0","title":"Nebulex.RPCMultiCallError.t/0","type":"type"},{"doc":"Raised at runtime when the cache was not started or it does not exist.","ref":"Nebulex.RegistryLookupError.html","title":"Nebulex.RegistryLookupError","type":"exception"},{"doc":"","ref":"Nebulex.RegistryLookupError.html#t:t/0","title":"Nebulex.RegistryLookupError.t/0","type":"type"},{"doc":"This guide is an introduction to Nebulex , a local and distributed caching toolkit for Elixir. Nebulex API is pretty much inspired by Ecto , taking advantage of its simplicity, flexibility and pluggable architecture. In the same way as Ecto, developers can provide their own cache (adapter) implementations. In this guide, we're going to learn some basics about Nebulex, such as insert, retrieve and destroy cache entries.","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Let's start creating a new Elixir application by running this command: mix new blog -- sup The --sup option ensures that this application has a supervision tree , which will be needed by Nebulex later on. To add Nebulex to this application, there are a few steps that we need to take. The first step will be adding Nebulex to our mix.exs file, which we'll do by changing the deps definition in that file to this: defp deps do [ { :nebulex , &quot;~&gt; 2.3&quot; } , { :shards , &quot;~&gt; 1.0&quot; } , #=&gt; When using :shards as backend { :decorator , &quot;~&gt; 1.4&quot; } , #=&gt; When using Caching Annotations { :telemetry , &quot;~&gt; 1.0&quot; } #=&gt; When using the Telemetry events (Nebulex stats) ] end In order to give more flexibility and loading only needed dependencies, Nebulex makes all its dependencies as optional. For example: For intensive workloads, you may want to use :shards as the backend for the local adapter and having partitioned tables. In such a case, you have to add :shards to the dependency list. For enabling the usage of declarative annotation-based caching via decorators , you have to add :decorator to the dependency list. For enabling Telemetry events to be dispatched when using Nebulex, you have to add :telemetry to the dependency list. See telemetry guide . If you want to use an external adapter (e.g: Cachex or Redis adapter), you have to add the adapter dependency too. To install these dependencies, we will run this command: mix deps . get We now need to define a Cache and setup some configuration for Nebulex so that we can perform actions on a cache from within the application's code. We can set up this configuration by running this command: mix nbx . gen . cache - c Blog.Cache This command will generate the configuration required to use the cache. The first bit of configuration is in config/config.exs : config :blog , Blog.Cache , # When using :shards as backend # backend: :shards, # GC interval for pushing new generation: 12 hrs gc_interval : :timer . hours ( 12 ) , # Max 1 million entries in cache max_size : 1_000_000 , # Max 2 GB of memory allocated_memory : 2_000_000_000 , # GC min timeout: 10 sec gc_cleanup_min_timeout : :timer . seconds ( 10 ) , # GC min timeout: 10 min gc_cleanup_max_timeout : :timer . minutes ( 10 ) Assuming we will use :shards as backend, can add uncomment the first line in the config config :blog , Blog.Cache , # When using :shards as backend backend : :shards , # GC interval for pushing new generation: 12 hrs gc_interval : :timer . hours ( 12 ) , # Max 1 million entries in cache max_size : 1_000_000 , # Max 2 GB of memory allocated_memory : 2_000_000_000 , # GC min timeout: 10 sec gc_cleanup_min_timeout : :timer . seconds ( 10 ) , # GC min timeout: 10 min gc_cleanup_max_timeout : :timer . minutes ( 10 ) By default, partitions: option is set to System.schedulers_online() . NOTE: For more information about the provided options, see the adapter's documentation. And the Blog.Cache module is defined in lib/blog/cache.ex by our mix nbx.gen.cache command: defmodule Blog.Cache do use Nebulex.Cache , otp_app : :blog , adapter : Nebulex.Adapters.Local end This module is what we'll be using to interact with the cache. It uses the Nebulex.Cache module and it expects the :otp_app as option. The otp_app tells Nebulex which Elixir application it can look for cache configuration in. In this case, we've specified that it is the :blog application where Nebulex can find that configuration and so Nebulex will use the configuration that was set up in config/config.exs . The final piece of configuration is to setup the Blog.Cache as a supervisor within the application's supervision tree, which we can do in lib/blog/application.ex , inside the start/2 function: def start ( _type , _args ) do children = [ Blog.Cache ] ... This piece of configuration will start the Nebulex process which receives and executes our application's commands. Without it, we wouldn't be able to use the cache at all! We've now configured our application so that it's able to execute commands against our cache. IMPORTANT: Make sure the cache is put in first place within the children list, or at least before the process or processes using it. Otherwise, there could be race conditions causing Nebulex.RegistryLookupError errors; processes attempting to use the cache and this one hasn't been even started.","ref":"getting-started.html#adding-nebulex-to-an-application","title":"Getting Started - Adding Nebulex to an application","type":"extras"},{"doc":"We can insert a new entries into our blog cache with this code: iex&gt; user = %{ id : 1 , first_name : &quot;Galileo&quot; , last_name : &quot;Galilei&quot; } iex&gt; Blog.Cache . put ( user [ :id ] , user , ttl : :timer . hours ( 1 ) ) :ok To insert the data into our cache, we call put on Blog.Cache . This function tells Nebulex that we want to insert a new key/value entry into the cache corresponding Blog.Cache . It is also possible to insert multiple entries at once: iex&gt; users = %{ ...&gt; 1 =&gt; %{ id : 1 , first_name : &quot;Galileo&quot; , last_name : &quot;Galilei&quot; } , ...&gt; 2 =&gt; %{ id : 2 , first_name : &quot;Charles&quot; , last_name : &quot;Darwin&quot; } , ...&gt; 3 =&gt; %{ id : 3 , first_name : &quot;Albert&quot; , last_name : &quot;Einstein&quot; } ...&gt; } iex&gt; Blog.Cache . put_all ( users ) :ok The given entries can be a map or a Key/Value tuple list. Inserting new entries and replacing existing ones As we saw previously, put creates a new entry in cache if it doesn't exist, or overrides it if it does exist (including the :ttl ). However, there might be circumstances where we want to set the entry only if it doesn't exit or the other way around, this is where put_new and replace functions come in. Let's try put_new and put_new! functions: iex&gt; new_user = %{ id : 4 , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } iex&gt; Blog.Cache . put_new ( new_user . id , new_user , ttl : 900 ) true iex&gt; Blog.Cache . put_new ( new_user . id , new_user ) false # same as previous one but raises `Nebulex.KeyAlreadyExistsError` iex&gt; Blog.Cache . put_new! ( new_user . id , new_user ) Now replace and replace! functions: iex&gt; existing_user = %{ id : 5 , first_name : &quot;John&quot; , last_name : &quot;Doe2&quot; } iex&gt; Blog.Cache . replace ( existing_user . id , existing_user ) false iex&gt; Blog.Cache . put_new ( existing_user . id , existing_user ) true iex&gt; Blog.Cache . replace ( existing_user . id , existing_user , ttl : 900 ) true # same as previous one but raises `KeyError` iex&gt; Blog.Cache . replace! ( 100 , existing_user ) It is also possible to insert multiple new entries at once: iex&gt; new_users = %{ ...&gt; 6 =&gt; %{ id : 6 , first_name : &quot;Isaac&quot; , last_name : &quot;Newton&quot; } , ...&gt; 7 =&gt; %{ id : 7 , first_name : &quot;Marie&quot; , last_name : &quot;Curie&quot; } ...&gt; } iex&gt; Blog.Cache . put_new_all ( new_users ) true # none of the entries is inserted if at least one key already exists iex&gt; Blog.Cache . put_new_all ( new_users ) false","ref":"getting-started.html#inserting-entries","title":"Getting Started - Inserting entries","type":"extras"},{"doc":"Let’s start off with fetching data by the key, which is the most basic and common operation to retrieve data from a cache. iex&gt; Blog.Cache . get ( 1 ) _user_1 iex&gt; for key &lt;- 1 .. 3 do ...&gt; user = Blog.Cache . get ( key ) ...&gt; user . first_name ...&gt; end [ &quot;Galileo&quot; , &quot;Charles&quot; , &quot;Albert&quot; ] There is a function has_key? to check if a key exist in cache: iex&gt; Blog.Cache . has_key? ( 1 ) true iex&gt; Blog.Cache . has_key? ( 10 ) false Retrieving multiple entries iex&gt; Blog.Cache . get_all ( [ 1 , 2 , 3 ] ) _users","ref":"getting-started.html#retrieving-entries","title":"Getting Started - Retrieving entries","type":"extras"},{"doc":"Nebulex provides update and get_and_update functions to update an entry value based on current one, for example: iex&gt; initial = %{ id : 1 , first_name : &quot;&quot; , last_name : &quot;&quot; } # using `get_and_update` iex&gt; Blog.Cache . get_and_update ( 1 , fn v -&gt; ...&gt; if v , do : { v , %{ v | first_name : &quot;X&quot; } } , else : { v , initial } ...&gt; iex &gt; end ) { _old , _updated } # using `update` iex&gt; Blog.Cache . update ( 1 , initial , &amp; ( %{ &amp;1 | first_name : &quot;Y&quot; } ) ) _updated","ref":"getting-started.html#updating-entries","title":"Getting Started - Updating entries","type":"extras"},{"doc":"The function incr is provided to increment or decrement a counter; by default, a counter is initialized to 0 . Let's see how counters works: # by default, the counter is incremented by 1 iex&gt; Blog.Cache . incr ( :my_counter ) 1 # but we can also provide a custom increment value iex&gt; Blog.Cache . incr ( :my_counter , 5 ) 6 # to decrement the counter, just pass a negative value iex&gt; Blog.Cache . incr ( :my_counter , - 5 ) 1","ref":"getting-started.html#counters","title":"Getting Started - Counters","type":"extras"},{"doc":"We’ve now covered inserting, reading and updating entries. Now let's see how to delete an entry using Nebulex. iex&gt; Blog.Cache . delete ( 1 ) :ok Take This is another way not only for deleting an entry but also for retrieving it before its delete it: iex&gt; Blog.Cache . take ( 1 ) _entry # returns `nil` if `key` doesn&#39;t exist iex&gt; Blog.Cache . take ( &quot;nonexistent&quot; ) nil # same as previous one but raises `KeyError` iex&gt; Blog.Cache . take! ( &quot;nonexistent&quot; )","ref":"getting-started.html#deleting-entries","title":"Getting Started - Deleting entries","type":"extras"},{"doc":"The last thing we’ll cover in this guide is how to retrieve information about cached objects or the cache itself. Remaining TTL iex&gt; Blog.Cache . ttl ( 1 ) _remaining_ttl iex&gt; Blog.Cache . ttl ( &quot;nonexistent&quot; ) nil","ref":"getting-started.html#info","title":"Getting Started - Info","type":"extras"},{"doc":"Nebulex provides functions to fetch, count, delete, or stream all entries from cache matching the given query. Fetch all entries from cache matching the given query # by default, returns all keys iex&gt; Blog.Cache . all ( ) _all_entries # fetch all entries and return the keys iex&gt; Blog.Cache . all ( nil , return : :key ) _keys # built-in queries in `Nebulex.Adapters.Local` adapter iex&gt; Blog.Cache . all ( nil ) iex&gt; Blog.Cache . all ( :unexpired ) iex&gt; Blog.Cache . all ( :expired ) # if we are using `Nebulex.Adapters.Local` adapter, the stored entry # is a tuple `{:entry, key, value, touched, ttl}`, then the match spec # could be something like: iex&gt; spec = [ { { :_ , :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 10 } ] , [ { { :&quot;$1&quot; , :&quot;$2&quot; } } ] } ] iex&gt; Blog.Cache . all ( spec ) _all_matched # using Ex2ms iex&gt; import Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { _ , key , value , _ , _ } when value &gt; 10 -&gt; { key , value } ...&gt; end iex&gt; Blog.Cache . all ( spec ) _all_matched Count all entries from cache matching the given query For example, to get the total number of cached objects (cache size): iex&gt; Blog.Cache . count_all ( ) _num_cached_entries By default, since none query is given to count_all/2 , all entries in cache match. In the same way as all/2 , you can pass a query to count only the matched entries: # using Ex2ms iex&gt; import Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { _ , value , _ , _ } when rem ( value , 2 ) == 0 -&gt; true ...&gt; end iex&gt; Blog.Cache . count_all ( spec ) _num_of_matched_entries The previous example assumes you are using the built-in local adapter. Also, if you are using the built-in local adapter, you can use the queries :expired and :unexpired too, like so: iex&gt; expired_entries = Blog.Cache . count_all ( :expired ) iex&gt; unexpired_entries = Blog.Cache . count_all ( :unexpired ) Delete all entries from cache matching the given query Similar to count_all/2 , Nebulex provides delete_all/2 to not only count the matched entries but also remove them from the cache at once, in one single execution. The first example is flushing the cache, delete all cached entries (which is the default behavior when none query is provided): iex&gt; Blog.Cache . delete_all ( ) _num_of_removed_entries And just like count_all/2 , you can also provide a custom query to delete only the matched entries, or if you are using the built-in local adapter you can also use the queries :expired and :unexpired . For example: iex&gt; expired_entries = Blog.Cache . delete_all ( :expired ) iex&gt; unexpired_entries = Blog.Cache . delete_all ( :unexpired ) # using Ex2ms iex&gt; import Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { _ , value , _ , _ } when rem ( value , 2 ) == 0 -&gt; true ...&gt; end iex&gt; Blog.Cache . delete_all ( spec ) _num_of_matched_entries These examples assumes you are using the built-in local adapter. Stream all entries from cache matching the given query Similar to all/2 but returns a lazy enumerable that emits all entries from the cache matching the provided query. If the query is nil , then all entries in cache match and are returned when the stream is evaluated; based on the :return option. iex&gt; Blog.Cache . stream ( ) iex&gt; Blog.Cache . stream ( nil , page_size : 100 , return : :value ) iex&gt; Blog.Cache . stream ( nil , page_size : 100 , return : :entry ) # using `Nebulex.Adapters.Local` adapter iex&gt; spec = [ { { :&quot;$1&quot; , :&quot;$2&quot; , :_ , :_ } , [ { :&gt; , :&quot;$2&quot; , 10 } ] , [ { { :&quot;$1&quot; , :&quot;$2&quot; } } ] } ] iex&gt; Blog.Cache . stream ( spec ) _all_matched # using Ex2ms iex&gt; import Ex2ms iex&gt; spec = ...&gt; fun do ...&gt; { key , value , _ , _ } when value &gt; 10 -&gt; { key , value } ...&gt; end iex&gt; Blog.Cache . stream ( spec ) _all_matched","ref":"getting-started.html#query-and-or-stream-entries","title":"Getting Started - Query and/or Stream entries","type":"extras"},{"doc":"Nebulex provides the adapter Nebulex.Adapters.Partitioned , which allows to set up a partitioned cache topology. Let's set up the partitioned cache by using the mix task mix nbx.gen.cache : mix nbx . gen . cache - c Blog.PartitionedCache - a Nebulex.Adapters.Partitioned As we saw previously, this command will generate the cache in lib/bolg/partitioned_cache.ex (in this case using the partitioned adapter) module along with the initial configuration in config/config.exs . The cache: defmodule Blog.PartitionedCache do use Nebulex.Cache , otp_app : :blog , adapter : Nebulex.Adapters.Partitioned , primary_storage_adapter : Nebulex.Adapters.Local end And the config: config :blog , Blog.PartitionedCache , primary : [ # When using :shards as backend backend : :shards , # GC interval for pushing new generation: 12 hrs gc_interval : :timer . hours ( 12 ) , # Max 1 million entries in cache max_size : 1_000_000 , # Max 2 GB of memory allocated_memory : 2_000_000_000 , # GC min timeout: 10 sec gc_cleanup_min_timeout : :timer . seconds ( 10 ) , # GC min timeout: 10 min gc_cleanup_max_timeout : :timer . minutes ( 10 ) ] And remember to add the new cache Blog.PartitionedCache to your application's supervision tree (such as we did it previously): def start ( _type , _args ) do children = [ Blog.Cache , Blog.PartitionedCache ] ... Now we are ready to start using our partitioned cache! Timeout option The Nebulex.Adapters.Partitioned supports :timeout option, it is a value in milliseconds for the command that will be executed. iex&gt; Blog.PartitionedCache . get ( &quot;foo&quot; , timeout : 10 ) _value # if the timeout is exceeded, then the current process will exit iex&gt; Blog.PartitionedCache . put ( &quot;foo&quot; , &quot;bar&quot; , timeout : 10 ) # ** (EXIT) time out To learn more about how partitioned cache works, please check Nebulex.Adapters.Partitioned documentation, and also it is recommended see the partitioned cache example","ref":"getting-started.html#partitioned-cache","title":"Getting Started - Partitioned Cache","type":"extras"},{"doc":"Nebulex also provides the adapter Nebulex.Adapters.Multilevel , which allows to setup a multi-level caching hierarchy. First, let's set up the multi-level cache by using the mix task mix nbx.gen.cache : mix nbx . gen . cache - c Blog.NearCache - a Nebulex.Adapters.Multilevel By default, the command generates a 2-level near-cache topology. The first level or L1 using the built-in local adapter, and the second one or L2 using the built-in partitioned adapter. The generated cache module lib/blog/near_cache.ex : defmodule Blog.NearCache do use Nebulex.Cache , otp_app : :blog , adapter : Nebulex.Adapters.Multilevel ## Cache Levels # Default auto-generated L1 cache (local) defmodule L1 do use Nebulex.Cache , otp_app : :blog , adapter : Nebulex.Adapters.Local end # Default auto-generated L2 cache (partitioned cache) defmodule L2 do use Nebulex.Cache , otp_app : :blog , adapter : Nebulex.Adapters.Partitioned end ## TODO: Add, remove or modify the auto-generated cache levels above end And the configuration ( config/config.exs ): config :blog , Blog.NearCache , model : :inclusive , levels : [ # Default auto-generated L1 cache (local) { Blog.NearCache.L1 , # GC interval for pushing new generation: 12 hrs gc_interval : :timer . hours ( 12 ) , # Max 1 million entries in cache max_size : 1_000_000 } , # Default auto-generated L2 cache (partitioned cache) { Blog.NearCache.L2 , primary : [ # GC interval for pushing new generation: 12 hrs gc_interval : :timer . hours ( 12 ) , # Max 1 million entries in cache max_size : 1_000_000 ] } ] Remember you can add backend: :shards to use Shards as backend. Finally, add the new cache Blog.NearCache to your application's supervision tree (such as we did it previously): def start ( _type , _args ) do children = [ Blog.Cache , Blog.PartitionedCache , Blog.NearCache ] ... Let's try it out! iex&gt; Blog.NearCache . put ( &quot;foo&quot; , &quot;bar&quot; , ttl : :timer . hours ( 1 ) ) &quot;bar&quot; iex&gt; Blog.NearCache . get ( &quot;foo&quot; ) &quot;bar&quot; To learn more about how multilevel-cache works, please check Nebulex.Adapters.Multilevel documentation, and also it is recommended see the near cache example","ref":"getting-started.html#multilevel-cache","title":"Getting Started - Multilevel Cache","type":"extras"},{"doc":"Cache Usage Patterns via Nebulex.Caching - Annotations-based DSL to implement different cache usage patterns.","ref":"getting-started.html#next","title":"Getting Started - Next","type":"extras"},{"doc":"There are several common access patterns when using a cache. Nebulex supports most of these patterns by means of Nebulex.Caching . Most of the following documentation about caching patterns it based on EHCache Docs","ref":"cache-usage-patterns.html","title":"Cache Usage Patterns via Nebulex.Caching","type":"extras"},{"doc":"With the cache-aside pattern, application code uses the cache directly. This means that application code which accesses the system-of-record (SoR) should consult the cache first, and if the cache contains the data, then return the data directly from the cache, bypassing the SoR. Otherwise, the application code must fetch the data from the system-of-record, store the data in the cache, and then return it. When data is written, the cache must be updated along with the system-of-record. Reading values if value = MyCache . get ( key ) do value else value = SoR . get ( key ) # maybe Ecto? :ok = MyCache . put ( key , value ) value end Writing values :ok = MyCache . put ( key , value ) SoR . insert ( key , value ) # maybe Ecto? As you may have noticed, this is the default behavior for most of the caches, we have to interact directly with the cache as well as the SoR (most likely the Database).","ref":"cache-usage-patterns.html#cache-aside","title":"Cache Usage Patterns via Nebulex.Caching - Cache-aside","type":"extras"},{"doc":"The cache-as-SoR pattern implies using the cache as though it were the primary system-of-record (SoR). The pattern delegates SoR reading and writing activities to the cache, so that application code is (at least directly) absolved of this responsibility. To implement the cache-as-SoR pattern, use a combination of the following read and write patterns: Read-through Write-through Advantages of using the cache-as-SoR pattern are: Less cluttered application code (improved maintainability through centralized SoR read/write operations) Choice of write-through or write-behind strategies on a per-cache basis Allows the cache to solve the thundering-herd problem A disadvantage of using the cache-as-SoR pattern is: Less directly visible code-path But how to get all this out-of-box? This is where declarative annotation-based caching comes in. Nebulex provides a set of annotation to abstract most of the logic behind Read-through and Write-through patterns and make the implementation extremely easy. But let's go over these patterns more in detail and how to implement them by using Nebulex annotations .","ref":"cache-usage-patterns.html#cache-as-sor","title":"Cache Usage Patterns via Nebulex.Caching - Cache-as-SoR","type":"extras"},{"doc":"Under the read-through pattern, the cache is configured with a loader component that knows how to load data from the system-of-record (SoR). When the cache is asked for the value associated with a given key and such an entry does not exist within the cache, the cache invokes the loader to retrieve the value from the SoR, then caches the value, then returns it to the caller. The next time the cache is asked for the value for the same key it can be returned from the cache without using the loader (unless the entry has been evicted or expired). This pattern can be easily implemented using cache decorator as follows: defmodule MyApp.Example do use Nebulex.Caching alias MyApp.Cache @ttl :timer . hours ( 1 ) @decorate cacheable ( cache : Cache , key : name ) def get_by_name ( name ) do # your logic (the loader to retrieve the value from the SoR) end @decorate cacheable ( cache : Cache , key : age , opts : [ ttl : @ttl ] ) def get_by_age ( age ) do # your logic (the loader to retrieve the value from the SoR) end @decorate cacheable ( cache : Cache ) def all ( query ) do # your logic (the loader to retrieve the value from the SoR) end end As you can see, the loader to retrieve the value from the system-of-record (SoR) is the function logic itself.","ref":"cache-usage-patterns.html#read-through","title":"Cache Usage Patterns via Nebulex.Caching - Read-through","type":"extras"},{"doc":"Under the write-through pattern, the cache is configured with a writer component that knows how to write data to the system-of-record (SoR). When the cache is asked to store a value for a key, the cache invokes the writer to store the value in the SoR, as well as updating (or deleting) the cache. This pattern can be implemented using defevict or defupdatable . When the data is written to the system-of-record (SoR), you can update the cached value associated with the given key using defupdatable , or just delete it using defevict . defmodule MyApp.Example do use Nebulex.Caching alias MyApp.Cache # When the data is written to the SoR, it is updated in the cache @decorate cache_put ( cache : Cache , key : something ) def update ( something ) do # Write data to the SoR (most likely the Database) end # When the data is written to the SoR, it is deleted (evicted) from the cache @decorate cache_evict ( cache : Cache , key : something ) def update_something ( something ) do # Write data to the SoR (most likely the Database) end end As you can see, the logic to write data to the system-of-record (SoR) is the function logic itself.","ref":"cache-usage-patterns.html#write-through","title":"Cache Usage Patterns via Nebulex.Caching - Write-through","type":"extras"},{"doc":"This guide is not focused on explaining :telemetry itself, how it works, how to configure it, and so on. Instead, we will show you how to instrument and report on Cache Telemetry events in your application when using Nebulex. For more information about :telemetry , you can check the documentation , or the Phoenix Telemetry guide is also recommended.","ref":"telemetry.html","title":"Telemetry","type":"extras"},{"doc":"Many Elixir libraries (including Nebulex) are already using the :telemetry package as a way to give users more insight into the behavior of their applications, by emitting events at key moments in the application lifecycle. Nebulex built-in events The following events are emitted by all Nebulex caches: [:nebulex, :cache, :init] - it is dispatched whenever a cache starts. Measurement: %{system_time: System.monotonic_time()} Metadata: %{cache: atom, opts: [term]} Adapter-specific events Nebulex currently suggests the adapters to dispatch the following Telemetry events: [:my_app, :cache, :command, :start] - Dispatched by the underlying cache adapter before an adapter callback is executed. Measurement: %{system_time: System.monotonic_time()} Metadata: %{adapter_meta: map, function_name: atom, args: [term]} [:my_app, :cache, :command, :stop] - Dispatched by the underlying cache adapter after an adapter callback has been successfully executed. Measurement: %{duration: native_time} Metadata: %{ adapter_meta : map , function_name : atom , args : [ term ] , result : term } [:my_app, :cache, :command, :exception] - Dispatched by the underlying cache adapter when an exception is raised while the adapter callback is executed. Measurement: %{duration: native_time} Metadata: %{ adapter_meta : map , function_name : atom , args : [ term ] , kind : :error | :exit | :throw , reason : term , stacktrace : term }","ref":"telemetry.html#telemetry-events","title":"Telemetry - Telemetry Events","type":"extras"},{"doc":"Assuming you have defined the cache MyApp.Cache with the default :telemetry_prefix , using Telemetry.Metrics , you can define a counter metric, which counts how many cache commands were completed: Telemetry.Metrics . counter ( &quot;my_app.cache.command.stop.duration&quot; ) or you could use a distribution metric to see how many commands were completed in particular time buckets: Telemetry.Metrics . distribution ( &quot;my_app.cache.command.stop.duration&quot; , buckets : [ 100 , 200 , 300 ] ) So far, these metrics are only helpful to be able to see just the total number of executed cache commands. What if you wanted to see the average command duration, minimum and maximum, or percentiles, but aggregated per command or callback name? In this case, one could define a summary metric like so: Telemetry.Metrics . summary ( &quot;my_app.cache.command.stop.duration&quot; , unit : { :native , :millisecond } , tags : [ :function_name ] ) As it is described above in the &quot;Adapter-specific events&quot; section, the event includes the invoked callback name into the metadata as :function_name , then we can add it to the metric's tags. Extracting tag values from adapter's metadata Let's add another metric for the command event, this time to group by cache , adapter , and function_name (adapter's callback): Telemetry.Metrics . summary ( &quot;my_app.cache.command.stop.duration&quot; , unit : { :native , :millisecond } , tags : [ :cache , :adapter , :function_name ] , tag_values : &amp; Map . merge ( &amp;1 , %{ cache : &amp;1 . adapter_meta . cache , adapter : &amp;1 . adapter_meta . cache . __adapter__ ( ) } ) ) We've introduced the :tag_values option here, because we need to perform a transformation on the event metadata in order to get to the values we need.","ref":"telemetry.html#nebulex-metrics","title":"Telemetry - Nebulex Metrics","type":"extras"},{"doc":"Each adapter is responsible for providing stats by implementing Nebulex.Adapter.Stats behaviour. However, Nebulex provides a simple default implementation using Erlang counters , which is used by the built-in local adapter. The local adapter uses Nebulex.Telemetry.StatsHandler to aggregate the stats and keep them updated, therefore, it requires the Telemetry events are dispatched by the adapter, otherwise, it won't work properly. Furthermore, when the :stats option is enabled, we can use Telemetry for emitting the current stat values. First of all, make sure you have added :telemetry , :telemetry_metrics , and :telemetry_poller packages as dependencies to your mix.exs file. Let's define out cache module: defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local end Make sure the :stats option is set to true , for example in the configuration: config :my_app , MyApp.Cache , stats : true , backend : :shards , gc_interval : :timer . hours ( 12 ) , max_size : 1_000_000 , gc_cleanup_min_timeout : :timer . seconds ( 10 ) , gc_cleanup_max_timeout : :timer . minutes ( 10 ) Create your Telemetry supervisor at lib/my_app/telemetry.ex : # lib/my_app/telemetry.ex defmodule MyApp.Telemetry do use Supervisor import Telemetry.Metrics def start_link ( arg ) do Supervisor . start_link ( __MODULE__ , arg , name : __MODULE__ ) end def init ( _arg ) do children = [ # Configure `:telemetry_poller` for reporting the cache stats { :telemetry_poller , measurements : periodic_measurements ( ) , period : 10_000 } , # For example, we use the console reporter, but you can change it. # See `:telemetry_metrics` for for information. { Telemetry.Metrics.ConsoleReporter , metrics : metrics ( ) } ] Supervisor . init ( children , strategy : :one_for_one ) end defp metrics do [ # Nebulex Stats Metrics last_value ( &quot;my_app.cache.stats.hits&quot; , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.misses&quot; , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.writes&quot; , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.updates&quot; , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.evictions&quot; , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.expirations&quot; , tags : [ :cache ] ) ] end defp periodic_measurements do [ { MyApp.Cache , :dispatch_stats , [ ] } ] end end Then add to your main application's supervision tree (usually in lib/my_app/application.ex ): children = [ MyApp.Cache , MyApp.Telemetry , ... ] Now start an IEx session and call the server: iex(1)&gt; MyApp.Cache . get 1 nil iex(2)&gt; MyApp.Cache . put 1 , 1 , ttl : 10 :ok iex(3)&gt; MyApp.Cache . get 1 1 iex(4)&gt; MyApp.Cache . put 2 , 2 :ok iex(5)&gt; MyApp.Cache . delete 2 :ok iex(6)&gt; Process . sleep ( 20 ) :ok iex(7)&gt; MyApp.Cache . get 1 nil iex(2)&gt; MyApp.Cache . replace 1 , 11 true and you should see something like the following output: [ Telemetry.Metrics.ConsoleReporter ] Got new event! Event name : my_app . cache . stats All measurements : %{ evictions : 2 , expirations : 1 , hits : 1 , misses : 2 , updates : 1 , writes : 2 } All metadata : %{ cache : MyApp.Cache } Metric measurement : :hits ( last_value ) With value : 1 Tag values : %{ cache : MyApp.Cache } Metric measurement : :misses ( last_value ) With value : 2 Tag values : %{ cache : MyApp.Cache } Metric measurement : :writes ( last_value ) With value : 2 Tag values : %{ cache : MyApp.Cache } Metric measurement : :updates ( last_value ) With value : 1 Tag values : %{ cache : MyApp.Cache } Metric measurement : :evictions ( last_value ) With value : 2 Tag values : %{ cache : MyApp.Cache } Metric measurement : :expirations ( last_value ) With value : 1 Tag values : %{ cache : MyApp.Cache } Custom metrics In the same way, for instance, you can add another periodic measurement for reporting the cache size: defmodule MyApp.Cache do use Nebulex.Cache , otp_app : :my_app , adapter : Nebulex.Adapters.Local def dispatch_cache_size do :telemetry . execute ( [ :my_app , :cache , :size ] , %{ value : size ( ) } , %{ cache : __MODULE__ , node : node ( ) } ) end end Now let's add a new periodic measurement to invoke dispatch_cache_size() through :telemetry_poller : defp periodic_measurements do [ { MyApp.Cache , :dispatch_stats , [ [ metadata : %{ node : node ( ) } ] ] } , { MyApp.Cache , :dispatch_cache_size , [ ] } ] end Notice the node name was added to the metadata so we can use it in the metric's tags. Metrics: defp metrics do [ # Nebulex Stats Metrics last_value ( &quot;my_app.cache.stats.hits&quot; , tags : [ :cache , :node ] ) , last_value ( &quot;my_app.cache.stats.misses&quot; , tags : [ :cache , :node ] ) , last_value ( &quot;my_app.cache.stats.writes&quot; , tags : [ :cache , :node ] ) , last_value ( &quot;my_app.cache.stats.updates&quot; , tags : [ :cache , :node ] ) , last_value ( &quot;my_app.cache.stats.evictions&quot; , tags : [ :cache , :node ] ) , last_value ( &quot;my_app.cache.stats.expirations&quot; , tags : [ :cache , :node ] ) , # Nebulex custom Metrics last_value ( &quot;my_app.cache.size.value&quot; , tags : [ :cache , :node ] ) ] end If you start an IEx session like previously, you should see the new metric too: [ Telemetry.Metrics.ConsoleReporter ] Got new event! Event name : my_app . cache . stats All measurements : %{ evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , updates : 0 , writes : 0 } All metadata : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :hits ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :misses ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :writes ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :updates ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :evictions ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :expirations ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost } [ Telemetry.Metrics.ConsoleReporter ] Got new event! Event name : my_app . cache . size All measurements : %{ value : 0 } All metadata : %{ cache : MyApp.Cache , node : :nonode@nohost } Metric measurement : :value ( last_value ) With value : 0 Tag values : %{ cache : MyApp.Cache , node : :nonode@nohost }","ref":"telemetry.html#cache-stats","title":"Telemetry - Cache Stats","type":"extras"},{"doc":"When using the multi-level adapter the returned stats measurements may look a bit different, because the multi-level adapter works as a wrapper for the configured cache levels, so the returned measurements are grouped and consolidated by level. For example, suppose you have the cache: defmodule MyApp.Multilevel do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Multilevel defmodule L1 do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Local end defmodule L2 do use Nebulex.Cache , otp_app : :nebulex , adapter : Nebulex.Adapters.Partitioned end end Then, when you run MyApp.Multilevel.stats() you get something like: % Nebulex.Stats { measurements : %{ l1 : %{ evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , updates : 0 , writes : 0 } , l2 : %{ evictions : 0 , expirations : 0 , hits : 0 , misses : 0 , updates : 0 , writes : 0 } } , metadata : %{ l1 : %{ cache : NMyApp.Multilevel.L1 , started_at : ~U[2021-01-10 13:06:04.075084Z] } , l2 : %{ cache : MyApp.Multilevel.L2.Primary , started_at : ~U[2021-01-10 13:06:04.089888Z] } , cache : MyApp.Multilevel , started_at : ~U[2021-01-10 13:06:04.066750Z] } } As you can see, the measurements map has the stats grouped by level, every key is an atom specifying the level and the value is a map with the stats and/or measurements for that level. Based on that, you could define the Telemetry metrics in this way: [ # L1 metrics last_value ( &quot;my_app.cache.stats.l1.hits&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :hits ] ) , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.l1.misses&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :misses ] ) , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.l1.writes&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :writes ] ) , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.l1.updates&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :updates ] ) , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.l1.evictions&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :evictions ] ) , tags : [ :cache ] ) , last_value ( &quot;my_app.cache.stats.l1.expirations&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l1 , :expirations ] ) , tags : [ :cache ] ) , # L2 metrics last_value ( &quot;my_app.cache.stats.l2.hits&quot; , event_name : &quot;my_app.cache.stats&quot; , measurement : &amp; get_in ( &amp;1 , [ :l2 , :hits ] ) , tags : [ :cache ] ) , ... ] If what you need is the aggregated stats for all levels, you can always define your own function to emit the Telemetry events. You just need to call MyApp.Multilevel.stats() and then you add the logic to process the results in the way you need. On the other hand, if you are using Datadog through the StatsD reporter, you could do the aggregation directly in Datadog.","ref":"telemetry.html#multi-level-cache-stats","title":"Telemetry - Multi-level Cache Stats","type":"extras"},{"doc":"For the v2, Nebulex introduces several breaking changes, so this guide aims to highlight most of these changes to make easier the transition to v2. Be aware this guide won't focus on every change, just the most significant ones that can affect how your application code interacts with the cache. Also, it is not a detailed guide about how to translate the current code from older versions to v2, just pointing out the areas the new documentation should be consulted on.","ref":"migrating-to-v2.html","title":"Migrating to v2.x","type":"extras"},{"doc":"This is one of the biggest changes. Version 1.x, most of the configuration options are resolved in compile-time, which has a lot of limitations. Since version 2.x, only few arguments are configured in compile-time when defining a cache, e.g.: otp_app: , adapter: , and primary_storage_adapter: (for partitioned and replicated adapters). The rest of configuration parameters are given via config file or at startup time. For more information and examples, see Nebulex.Cache , Nebulex.Adapters.Local , Nebulex.Adapters.Partitioned , Nebulex.Adapters.Replicated , Nebulex.Adapters.Multilevel .","ref":"migrating-to-v2.html#configuration","title":"Migrating to v2.x - Configuration","type":"extras"},{"doc":"There are several changes on the Nebulex.Cache API: The :return option is not available anymore, so it has to be removed. The :version option is not available anymore, so it has to be removed. Callback set/3 was refactored to put/3 . Callback set_many/2 was refactored to put_all/2 . Callback get_many/2 was refactored to get_all/2 . Callbacks add/3 and add!/3 were refactored to put_new/3 and put_new!/3 . Callback update_counter/3 was refactored to incr/3 and decr/3 . Callback add_or_replace/3 was removed. Callback object_info/2 was removed, and callbacks ttl/1 and touch/1 were added instead.","ref":"migrating-to-v2.html#cache-api","title":"Migrating to v2.x - Cache API","type":"extras"},{"doc":"Module Nebulex.Caching.Decorators was refactored to Nebulex.Caching – Keep in mind that since v1.2.x the caching decorators were included instead of the previous macros or DSL (this applies for version lower than v1.1.x). Decorator cache/3 was refactored to cacheable/3 . Decorator evict/3 was refactored to cache_evict/3 . Decorator update/3 was refactored to cache_put/3 . Improved the :match option to return not only a boolean but return a specific value to be cached (term -&gt; boolean | {true, term}) – If true the code-block evaluation result is cached as it is (the default). If {true, value} is returned, then the value is what is cached.","ref":"migrating-to-v2.html#declarative-annotation-based-caching-via-decorators","title":"Migrating to v2.x - Declarative annotation-based caching via decorators","type":"extras"},{"doc":"Since v2.x, pre/post hooks are deprecated and won't be longer supported by Nebulex , at least not directly. Mainly, because the hooks feature is not a common use-case and also it is something that can be be easily implemented on top of the Cache at the application level. However, to keep backward compatibility somehow, Nebulex provides decorators for implementing pre/post hooks very easily. For that reason, it is highly recommended to removed all pre/post hooks related code and adapt it to the new way. See Nebulex.Hook for more information.","ref":"migrating-to-v2.html#hooks","title":"Migrating to v2.x - Hooks","type":"extras"},{"doc":"There have been several and significant improvements on the built-in adapters, so it is also highly recommended to take a look at them; Nebulex.Adapters.Local , Nebulex.Adapters.Partitioned , Nebulex.Adapters.Replicated , and Nebulex.Adapters.Multilevel . In case of using a distributed adapter, the module Nebulex.Adapter.HashSlot was refactored to Nebulex.Adapter.Keyslot and the callback keyslot /2 to hash_slot/2 .","ref":"migrating-to-v2.html#built-in-adapters","title":"Migrating to v2.x - Built-In Adapters","type":"extras"},{"doc":"For older versions (&lt;= 1.x), the stats were implemented via a post-hook and the measurements were oriented for counting the number of times a cache function is called. But what is interesting and useful to see is, for instance, the number of writes, hits, misses, evictions, etc. Therefore, the whole stats' functionality was refactored entirely. This feature is not longer using pre/post hooks. Besides, pre/post hooks are deprecated in v2.x. The stats support is optional by implementing the Nebulex.Adapter.Stats behaviour from the adapter. However, Nebulex provides a default implementation using [Erlang counters][ https://erlang.org/doc/man/counters.html] which is supported by the local built-in adapter. See the Telemetry guide for more information. Since Nebulex 2.x on-wards, enabling stats is a matter of setting the option :stats to true . See Nebulex.Cache for more information.","ref":"migrating-to-v2.html#statistics","title":"Migrating to v2.x - Statistics","type":"extras"},{"doc":"mix nebulex.gen.cache was refactored to mix nbx.gen.cache . mix nebulex was refactored to mix nbx .","ref":"migrating-to-v2.html#mix-tasks","title":"Migrating to v2.x - Mix Tasks","type":"extras"}]